local _, core = ...;
WCCreator_Lib = {};

function WCCreator_Lib.UpdateVersionGuide(infoGuide, idGuide)
	local guide = nil;
	if (infoGuide == nil) then
		guide = WC_Lib.GetGuideByID(idGuide, "WCC");
	else
		guide = infoGuide;
	end
	guide.av_settings.version = guide.av_settings.version + 1;
	guide.av_settings.lastModified = UnitName("player").." - "..GetRealmName().." ("..date("%m/%d/%y %H:%M:%S")..")";
end

function WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func)
	local k = 1;
	local heightAllPins = 0;
	
	for i = 1, #arrayWithValue do
		local valueInfo = arrayWithValue[i];
		if (arrayFrame[i] == nil) then
			local mainFrame = CreateFrame("Frame", parent:GetName().."_Item"..i, parent);
			mainFrame:SetSize(parent:GetWidth(), 13);
			if (i == 1) then
				mainFrame:SetPoint("TOPLEFT", parent, "TOPLEFT");
			else
				mainFrame:SetPoint("TOPLEFT", arrayFrame[i - 1], "BOTTOMLEFT", 0, -10);
			end
			mainFrame.text = mainFrame:CreateFontString(nil, "OVERLAY", mainFrame);
			mainFrame.text:SetSize(mainFrame:GetWidth()-80, 0);
			mainFrame.text:SetFontObject("GameFontNormal");
			local text = i.." : ";
			if (arrayDisplayedValue ~= nil) then
				for j = 1, #arrayDisplayedValue do
					text = text.."|cffffffff"..tostring(valueInfo[arrayDisplayedValue[j]]).."|r";
					if (j ~= #arrayDisplayedValue) then
						text = text..", ";
					end
				end
			else
				text = text.."|cffffffff"..tostring(valueInfo).."|r";
			end
			mainFrame.text:SetText(text);
			mainFrame.text:SetPoint("LEFT");
			mainFrame.text:SetJustifyH("LEFT");
			
			mainFrame.delBtn = CreateFrame("Button", nil, mainFrame, "UIPanelButtonTemplate");
			mainFrame.delBtn.i = i;
			mainFrame.delBtn:SetSize(24, 22);
			mainFrame.delBtn:SetText("X");
			mainFrame.delBtn:SetPoint("RIGHT");
			mainFrame.delBtn:SetScript("OnClick", function(self)
				table.remove(arrayWithValue, self.i);
				WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
				if (func ~= nil) then func() end
				WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
				PlaySound("882", "sfx");
			end);
			
			mainFrame.btn_arrowDown = CreateFrame("Button", nil, mainFrame);
			mainFrame.btn_arrowDown:SetSize(29, 29);
			mainFrame.btn_arrowDown:SetPoint("RIGHT", mainFrame.delBtn, "LEFT", 0, 0);
			mainFrame.btn_arrowDown:SetNormalTexture("Interface/Buttons/UI-Panel-ExpandButton-Up");
			mainFrame.btn_arrowDown:SetHighlightTexture("Interface/Buttons/UI-Panel-MinimizeButton-Highlight");
			mainFrame.btn_arrowDown:SetPushedTexture("Interface/Buttons/UI-Panel-ExpandButton-Down");
			mainFrame.btn_arrowDown:SetScript("OnClick", function(self)
				if (i < #arrayWithValue) then
					arrayWithValue[i], arrayWithValue[i + 1] = arrayWithValue[i + 1], arrayWithValue[i];
					WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
					if (func ~= nil) then func() end
					WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
					PlaySound("123", "sfx");
				end
			end);
			mainFrame.btn_arrowUp = CreateFrame("Button", nil, mainFrame);
			mainFrame.btn_arrowUp:SetSize(29, 29);
			mainFrame.btn_arrowUp:SetPoint("RIGHT", mainFrame.btn_arrowDown, "LEFT", 2, 0);
			mainFrame.btn_arrowUp:SetNormalTexture("Interface/Buttons/UI-Panel-CollapseButton-Up");
			mainFrame.btn_arrowUp:SetHighlightTexture("Interface/Buttons/UI-Panel-MinimizeButton-Highlight");
			mainFrame.btn_arrowUp:SetPushedTexture("Interface/Buttons/UI-Panel-CollapseButton-Down");
			mainFrame.btn_arrowUp:SetScript("OnClick", function(self)
				if (i > 1) then
					arrayWithValue[i], arrayWithValue[i - 1] = arrayWithValue[i - 1], arrayWithValue[i];
					WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
					if (func ~= nil) then func() end
					WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
					PlaySound("123", "sfx");
				end
			end);
			arrayFrame[i] = mainFrame;
		else
			local text = i.." : ";
			if (arrayDisplayedValue ~= nil) then
				for j = 1, #arrayDisplayedValue do
					text = text.."|cffffffff"..tostring(valueInfo[arrayDisplayedValue[j]]).."|r";
					if (j ~= #arrayDisplayedValue) then
						text = text..", ";
					end
				end
			else
				text = text.."|cffffffff"..tostring(valueInfo).."|r";
			end
			arrayFrame[i].delBtn.i = i;
			arrayFrame[i].text:SetText(text);
			arrayFrame[i]:Show();
			
			--- Maj des click buttons ---
			_G[parent:GetName().."_Item"..i].delBtn:SetScript("OnClick", function(self)
				table.remove(arrayWithValue, self.i);
				WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
				if (func ~= nil) then func() end
				WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
				PlaySound("882", "sfx");
			end);
			_G[parent:GetName().."_Item"..i].btn_arrowUp:SetScript("OnClick", function(self)
				if (i > 1) then
					arrayWithValue[i], arrayWithValue[i - 1] = arrayWithValue[i - 1], arrayWithValue[i];
					WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
					if (func ~= nil) then func() end
					WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
					PlaySound("123", "sfx");
				end
			end);
			_G[parent:GetName().."_Item"..i].btn_arrowDown:SetScript("OnClick", function(self)
				if (i < #arrayWithValue) then
					arrayWithValue[i], arrayWithValue[i + 1] = arrayWithValue[i + 1], arrayWithValue[i];
					WCCreator_Lib.RefreshListOfItem(parent, arrayWithValue, arrayFrame, arrayDisplayedValue, minimumItem, func);
					if (func ~= nil) then func() end
					WCCreator_Lib.UpdateVersionGuide(nil, parent.idGuide);
					PlaySound("123", "sfx");
				end
			end);
		end
		if (minimumItem ~= nil and #arrayWithValue == minimumItem) then
			arrayFrame[i].delBtn:Disable();
		else
			arrayFrame[i].delBtn:Enable();
		end
		heightAllPins = heightAllPins + arrayFrame[i]:GetHeight()*1.75;
		k = k + 1;
	end
	-- HIDE LES PINS EN TROP
	for k = k, #arrayFrame do
		arrayFrame[k]:Hide();
	end
	if (heightAllPins > 0) then
		parent:SetSize(parent:GetWidth(), heightAllPins);
	else
		parent:SetSize(parent:GetWidth(), 5);
	end
end

----- LIST VARIATION MODEL ITEM VIEW -----
local function UpdateListVariation(idItem, page, onPlayer)
	for i = 0, 5 do
		_G["WCC_ListVariationModelView_ModelScene"..i.."Text"]:SetText(i+(5*(page-1)));
		_G["WCC_ListVariationModelView_ModelScene"..i]:SetCamDistanceScale(1);
		_G["WCC_ListVariationModelView_ModelScene"..i]:SetRotation(0.75);
		_G["WCC_ListVariationModelView_ModelScene"..i].cursorX     = 0;
		_G["WCC_ListVariationModelView_ModelScene"..i].camDistance = 1;
		_G["WCC_ListVariationModelView_ModelScene"..i]:SetUnit("player");
		if (onPlayer ~= nil and onPlayer == true) then
			_G["WCC_ListVariationModelView_ModelScene"..i]:Undress() 
			local _, sourceID = C_TransmogCollection.GetItemInfo(idItem, i+(5*(page-1)))
			local displayID = sourceID or "item:"..idItem;
			WC_wait(0.5, WC_Lib.SetAppearanceToModel, _G["WCC_ListVariationModelView_ModelScene"..i], displayID, i+(5*(page-1)));
		else
			_G["WCC_ListVariationModelView_ModelScene"..i]:SetItem(idItem, i+(5*(page-1)));
		end
	end
end

function WCCreator_Lib.ShowListVariationModelView(idItem, IsOnPlayer)
	local page = 1;
	if (_G["WCC_ListVariationModelView"] == nil) then
		local mainFrame = CreateFrame("Frame", "WCC_ListVariationModelView", UIParent, BackdropTemplateMixin and "BackdropTemplate");
		mainFrame:SetSize(840,615);
		mainFrame:SetFrameLevel(507);
		mainFrame:SetPoint("CENTER", UIParent, "CENTER");
		mainFrame:SetBackdrop({bgFile = [[Interface\GLUES\COMMON\Glue-Tooltip-Background]],
						edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", edgeSize = 26,
						insets = {left = 5, right = 5, top = 5, bottom = 5}});
		mainFrame.close = CreateFrame("Button", "WCC_ListVariationModelView_BtnClose", mainFrame, "UIPanelCloseButton");
		mainFrame.close:SetSize(32, 32);
		mainFrame.close:SetPoint("TOPRIGHT", mainFrame, "TOPRIGHT", -7, -8);
		mainFrame.close:SetScript("OnClick", function(self)
			mainFrame:Hide();
			PlaySound("854", "sfx");
		end);
		
		for i = 0, 5 do
			mainFrame.ModelScene = CreateFrame("DressUpModel", "WCC_ListVariationModelView_ModelScene"..i, mainFrame, nil);
			mainFrame.ModelScene:SetSize(260,260);
			if (i == 0) then
				mainFrame.ModelScene:SetPoint("TOPLEFT", 25, -40);
			elseif (i == 3) then
				mainFrame.ModelScene:SetPoint("TOP", "WCC_ListVariationModelView_ModelScene"..(i - 3), "BOTTOM", 0, -5);
			else
				mainFrame.ModelScene:SetPoint("LEFT", "WCC_ListVariationModelView_ModelScene"..(i - 1), "RIGHT", 5, 0);
			end
			mainFrame.ModelScene.Text = mainFrame.ModelScene:CreateFontString("WCC_ListVariationModelView_ModelScene"..i.."Text", "OVERLAY", mainFrame.ModelScene);
			mainFrame.ModelScene.Text:SetFontObject("GameFontHighlightLarge");
			mainFrame.ModelScene.Text:SetPoint("TOP", mainFrame.ModelScene, "TOP", 0, -5);
			mainFrame.ModelScene.Text:SetText(i);
			mainFrame.ModelScene:SetFrameLevel(mainFrame:GetFrameLevel() + 1);
			mainFrame.ModelScene:SetKeepModelOnHide(true);
			mainFrame.ModelScene:SetCamDistanceScale(1);
			mainFrame.ModelScene:SetRotation(0.75);
			mainFrame.ModelScene.cursorX     = 0;
			mainFrame.ModelScene.camDistance = 1;
			mainFrame.ModelScene:SetScript("OnMouseWheel", WC_Lib.ModelOnMouseWheel);
			mainFrame.ModelScene:SetScript("OnMouseDown", WC_Lib.ModelOnMouseDown);
			mainFrame.ModelScene:SetScript("OnMouseUp", WC_Lib.ModelOnMouseUp);
			
			local bg = mainFrame.ModelScene:CreateTexture(nil, "BACKGROUND");
			bg:SetAllPoints(true);
			bg:SetColorTexture(0.75, 0.75, 0.75, 1);
		end
		mainFrame.ButtonPart = CreateFrame("Frame", nil, mainFrame);
		mainFrame.ButtonPart:SetPoint("BOTTOM", mainFrame, "BOTTOM");
		mainFrame.ButtonPart:SetSize(300,50);
		
		mainFrame.Afterbtn = CreateFrame("Button", nil, mainFrame.ButtonPart, "UIPanelButtonTemplate");
		mainFrame.Afterbtn:SetSize(100, 25);
		mainFrame.Afterbtn:SetText(core.L["Next"]);
		mainFrame.Afterbtn:SetPoint("RIGHT", mainFrame.ButtonPart, "RIGHT");
		mainFrame.Afterbtn.idItem     = idItem;
		mainFrame.Afterbtn.page       = page;
		mainFrame.Afterbtn.IsOnPlayer = IsOnPlayer;
		mainFrame.Afterbtn:SetScript("OnClick", function(self)
			local currPage           = self.page + 1;
			self.page                = currPage;
			mainFrame.Beforebtn.page = currPage;
			mainFrame.NbPage:SetText(self.page);
			UpdateListVariation(self.idItem, self.page, self.IsOnPlayer);
			if (self.page > 1) then
				mainFrame.Beforebtn:Enable();
			end
			PlaySound("83", "sfx");
		end);

		mainFrame.NbPage = mainFrame:CreateFontString(nil, "OVERLAY", mainFrame.ButtonPart);
		mainFrame.NbPage:SetFontObject("GameFontHighlightLarge");
		mainFrame.NbPage:SetPoint("CENTER", mainFrame.ButtonPart, "CENTER");
		mainFrame.NbPage:SetText(tostring(page));

		mainFrame.Beforebtn = CreateFrame("Button", nil, mainFrame.ButtonPart, "UIPanelButtonTemplate");
		mainFrame.Beforebtn:SetSize(100, 25);
		mainFrame.Beforebtn:SetText(core.L["Previous"]);
		mainFrame.Beforebtn:SetPoint("LEFT", mainFrame.ButtonPart, "LEFT");
		mainFrame.Beforebtn:Disable();
		mainFrame.Beforebtn.idItem     = idItem;
		mainFrame.Beforebtn.page       = page;
		mainFrame.Beforebtn.IsOnPlayer = IsOnPlayer;
		mainFrame.Beforebtn:SetScript("OnClick", function(self)
			local currPage          = self.page - 1;
			self.page               = currPage;
			mainFrame.Afterbtn.page = currPage;
			mainFrame.NbPage:SetText(self.page);
			UpdateListVariation(self.idItem, self.page, self.IsOnPlayer);
			if (self.page == 1) then
				self:Disable();
			end
			PlaySound("83", "sfx");
		end);
	else
		_G["WCC_ListVariationModelView"].Beforebtn:Disable();
		_G["WCC_ListVariationModelView"].NbPage:SetText(tostring(page));
		_G["WCC_ListVariationModelView"].Afterbtn.idItem      = idItem;
		_G["WCC_ListVariationModelView"].Afterbtn.page        = page;
		_G["WCC_ListVariationModelView"].Afterbtn.IsOnPlayer  = IsOnPlayer;
		_G["WCC_ListVariationModelView"].Beforebtn.idItem     = idItem;
		_G["WCC_ListVariationModelView"].Beforebtn.page       = page;
		_G["WCC_ListVariationModelView"].Beforebtn.IsOnPlayer = IsOnPlayer;
	end
	UpdateListVariation(idItem, page, IsOnPlayer)
	_G["WCC_ListVariationModelView"]:Show();
	PlaySound("681", "sfx");
end
----- END LIST VARIATION MODEL ITEM VIEW -----


function WCCreator_Lib.ShowPopupModelView(category, idModel, modID)
	if (_G["WCC_PopupModelView"] == nil) then
		local PopupModelView = CreateFrame("DressUpModel", "WCC_PopupModelView", UIParent, BackdropTemplateMixin and "BackdropTemplate");
		PopupModelView:SetSize(350,375);
		PopupModelView:SetFrameLevel(507);
		PopupModelView:SetKeepModelOnHide(true);
		PopupModelView:SetPoint("CENTER", UIParent, "CENTER");
		PopupModelView:SetBackdrop({bgFile = [[Interface\GLUES\COMMON\Glue-Tooltip-Background]],
						edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", edgeSize = 26,
						insets = {left = 5, right = 5, top = 5, bottom = 5}});
		PopupModelView:SetCamDistanceScale(1.5);
		PopupModelView:SetRotation(0.75);
		PopupModelView.cursorX     = 0;
		PopupModelView.camDistance = 1.5;
		PopupModelView:SetScript("OnMouseWheel", WC_Lib.ModelOnMouseWheel);
		PopupModelView:SetScript("OnMouseDown", WC_Lib.ModelOnMouseDown);
		PopupModelView:SetScript("OnMouseUp", WC_Lib.ModelOnMouseUp);
		PopupModelView.close = CreateFrame("Button", "WCC_PopupModelView_BtnClose", PopupModelView, "UIPanelCloseButton");
		PopupModelView.close:SetSize(32, 32);
		PopupModelView.close:SetPoint("TOPRIGHT", PopupModelView, "TOPRIGHT", -7, -8);
		PopupModelView.close:SetScript("OnClick", function(self)
			PopupModelView:Hide();
			PlaySound("854", "sfx");
		end);
	end
	if (idModel ~= nil and idModel ~= "" and idModel ~= 0 and tonumber(idModel) < 2147483647) then
		if (category == "transmogs") then
			_G["WCC_PopupModelView"]:SetItem(idModel, modID);
		elseif (category == "ENV") then
			_G["WCC_PopupModelView"]:SetModel(idModel);
		else
			_G["WCC_PopupModelView"]:SetDisplayInfo(idModel);
		end
	else
		_G["WCC_PopupModelView"]:ClearModel();
	end
	_G["WCC_PopupModelView"]:Show();
	PlaySound("681", "sfx");
end

function WCCreator_Lib.TextBoxSetDisable(tb_frame)
	tb_frame:Disable();
	tb_frame:SetFontObject("GameFontDarkGraySmall");
	tb_frame.title:SetFontObject("GameFontDisable");
end

function WCCreator_Lib.TextBoxSetEnable(tb_frame)
	tb_frame:Enable();
	tb_frame:SetFontObject("GameFontWhite");
	tb_frame.title:SetFontObject("GameFontNormal");
end

function WCCreator_Lib.CreateCustomFrame(frameSettings, frameParent, parentPopup)
	if frameSettings.frameType == "textbox" then
		return WCCreator_Lib.CreateTextBox(frameSettings, frameParent);
	elseif frameSettings.frameType == "multiline" then
		return WCCreator_Lib.CreateMultiline(frameSettings, frameParent);
	elseif frameSettings.frameType == "dropdownmenu" then
		return WCCreator_Lib.CreateDropDownMenu(frameSettings, frameParent);
	elseif frameSettings.frameType == "checkbox" then
		return WCCreator_Lib.CreateCheckBox(frameSettings, frameParent);
	end
	print("Error CreateCustomFrame");
end

function WCCreator_Lib.checkIfLetter(str, bFloat, bNegative)
	for z = 1, #str do
		local letter = str:sub(z, z)
		if (letter < "0" or letter > "9") then
			if (letter == '.') then
				if (bFloat ~= nil and bFloat ~= false) then
				else
					return true;
				end
			elseif (letter == '-') then
				if (bNegative ~= nil and bNegative ~= false and z == 1) then
				else
					return true;
				end
			else
				return true;
			end
		end
	end
	return false;
end

function WCCreator_Lib.checkIfMultipleLetter(str, letter, nb)
	local multiple = 0;
	for z = 1, #str do
		local strsub = str:sub(z, z);
		if (letter == strsub) then
			multiple = multiple + 1;
		end
	end
	if (multiple >= nb) then
		return true;
	else
		return false;
	end
end

function WCCreator_Lib.getNameAndIconItemById(id)
	local name = nil;
	local icon = nil;
	
	name, _, _, _, _, _, _, _, _, icon = GetItemInfo(tonumber(id));
	return unpack({name, icon});
end


function WCCreator_Lib.deepCopy(original)
	local copy = {}
	for k, v in pairs(original) do
		if type(v) == "table" then
			v = WCCreator_Lib.deepCopy(v)
		end
		copy[k] = v
	end
	return copy
end

function WCCreator_Lib.DuplicateCollection(idGuide)
	local guide    = WC_Lib.GetGuideByID(idGuide, "WCC");
	local guidePos = WC_Lib.GetPosGuideByID(idGuide, "WCC");
	local duplicateGuide   = WCCreator_Lib.deepCopy(guide);
	duplicateGuide.idGuide = WCCreator_Lib.GenerateIDGuide();
	table.insert(YourGuides, #YourGuides + 1, duplicateGuide);
	table.insert(ListGuides, guidePos + 1, duplicateGuide.idGuide);
	WC_Lib.RefreshListCollections("WCC");
end


function WCCreator_Lib.SwitchValidEdit(frameName, bShow)
	if (_G[frameName] ~= nil) then
		_G[frameName.."Valid"]:SetText(_G[frameName]:GetText());
		_G[frameName.."Valid"]:SetShown(not bShow);
		_G[frameName.."ValidBtn"]:SetShown(not bShow);
		_G[frameName]:SetShown(bShow);
		_G[frameName.."Btn"]:SetShown(bShow);
	end
end