local _, core = ...;

------ CREATE TITLE ------
function WCCreator_Lib.CreateCheckBox(settings, parent)
	local checkbox = CreateFrame("CheckButton", "WCC_"..settings.frameType.."_"..settings.frameTitle, parent, "ChatConfigSmallCheckButtonTemplate");
	checkbox:ClearAllPoints();
	checkbox:SetSize(settings.size, settings.size);
	checkbox:SetChecked(settings.checked);
	checkbox:SetText(settings.title);
	if (settings.disabled == true) then
		checkbox:Disable();
	end
	if (settings.desc ~= nil) then
		checkbox.title = settings.title;
		checkbox.desc  = settings.desc;
		checkbox:SetScript("OnEnter", WCCreator_Lib.tooltip.tooltip_FieldHelp);
		checkbox:SetScript("OnLeave", WCCreator_Lib.tooltip.OnLeave);
	end
	if (settings.func ~= nil) then
		checkbox:SetScript("OnClick", settings.func);
	end
	
	checkbox.titleFrame = checkbox:CreateFontString("WCC_"..settings.frameType.."_"..settings.frameTitle.."Title", "OVERLAY", checkbox);
	checkbox.titleFrame:SetFontObject("GameFontNormal");
	checkbox.titleFrame:SetText(settings.title);
	checkbox.titleFrame:SetPoint("LEFT", checkbox, "RIGHT", 0, 0);
	
	return checkbox;
end