------ CREATE TEXTBOX ------
function WCCreator_Lib.CreateTextBox(settings, parent)
	local textBox = CreateFrame("EditBox",  "WCC_"..settings.frameType.."_"..settings.frameTitle, parent, "InputBoxTemplate");
	textBox:SetSize(settings.width, 30);
	textBox:SetFontObject("GameFontWhite");
	textBox:SetAutoFocus(false);
	textBox:SetScript("OnEditFocusLost", WCCreator_Lib.tooltip.OnLeaveFieldHelp);
	textBox:SetScript("OnEditFocusGained", WCCreator_Lib.tooltip.tooltip_ShowFieldHelp);
	
	textBox.title = textBox:CreateFontString("WCC_"..settings.frameType.."_"..settings.frameTitle.."Title", "OVERLAY", textBox);
	textBox.title:SetFontObject("GameFontNormal");
	textBox.title:SetText(settings.title);
	textBox.title:SetPoint("BOTTOMLEFT", textBox, "TOPLEFT", -3, -6);

	if (settings.desc ~= nil) then
		textBox.helpIcon = CreateFrame("Frame", "WCC_"..settings.frameType.."_"..settings.frameTitle.."Help", textBox, "UIPanelInfoButton");
		textBox.helpIcon.title = settings.title;
		textBox.helpIcon.desc = settings.desc;
		textBox.helpIcon:SetSize(16, 16);
		textBox.helpIcon:SetPoint("RIGHT", textBox, "RIGHT", -2, 0);
		textBox.helpIcon:Hide();
		textBox.helpIcon:SetScript("OnLeave", WCCreator_Lib.tooltip.OnLeave);
		textBox.helpIcon:SetScript("OnEnter", WCCreator_Lib.tooltip.tooltip_FieldHelp);
	end

	if (settings.nbOnly ~= nil) then
		textBox:SetNumeric(true);
	end

	if (settings.event ~= nil) then
		for i = 1, #settings.event do
			textBox:SetScript(settings.event[i].name, settings.event[i].func);
		end
	end
	
	if (settings.button ~= nil) then
		textBox.button = CreateFrame("Button", "WCC_"..settings.frameType.."_"..settings.frameTitle.."Btn", textBox, "UIPanelButtonTemplate");
		textBox.button:SetSize(settings.button.width, 25);
		textBox.button:SetText(settings.button.title);
		textBox.button:SetPoint("TOPLEFT", textBox, "BOTTOMLEFT", -5, 5);
		textBox.button.title = settings.button.title;
		textBox.button.desc = settings.button.desc;
		textBox.button:SetScript("OnLeave", WCCreator_Lib.tooltip.OnLeave);
		if (textBox.button.desc ~= nil) then
			textBox.button:SetScript("OnEnter", WCCreator_Lib.tooltip.tooltip_FieldHelp);
		end
		textBox.button:SetScript("OnClick", settings.button.func);
	end
	return textBox;
end