local _, core = ...;
WCCreator_Lib.tooltip = {};

------ GAMETOOLTIP ------
WCCreator_Lib.tooltip.tooltip_FieldHelp = function(self, motion)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, 0);
	GameTooltip:AddLine(self.title, 1, 1, 1);
	GameTooltip:AddLine(self.desc, 1, 0.82, 0, true);
	GameTooltip:Show();
end

WCCreator_Lib.tooltip.tooltip_ShowFieldHelp = function(self, motion)
	if (self.helpIcon ~= nil) then
		self.helpIcon:Show();
	end
end

WCCreator_Lib.tooltip.tooltip_WCCreatorOn = function(self, motion)
	GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 0);
	GameTooltip:AddLine("WoW Challenger Creator", 1, 1, 1);
	GameTooltip:AddLine(core.L["Cliquer pour passer en mode créatif"]);
	GameTooltip:Show();
end

WCCreator_Lib.tooltip.tooltip_WCCreatorOff = function(self, motion)
	GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 0);
	GameTooltip:AddLine("WoW Challenger", 1, 1, 1);
	GameTooltip:AddLine(core.L["Cliquer pour quitter le mode créatif"]);
	GameTooltip:Show();
end

WCCreator_Lib.tooltip.OnLeave = function(self, motion)
	GameTooltip:Hide()
end

WCCreator_Lib.tooltip.OnLeaveFieldHelp = function(self, motion)
	if (self.helpIcon ~= nil) then
		self.helpIcon:Hide()
	end
end

WCCreator_Lib.tooltip.tooltip_av_settings = function(self, motion)
	local MS = WCCreator_Lib.structures.MainSettings_value;
	GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 0);
	GameTooltip:AddLine(MS.name, 1, 1, 1);
	if (MS.idGuide ~= nil and MS.idGuide ~= "") then
		GameTooltip:AddLine(core.L["ID Guide"]..core.L["2points"].."|cff00c8ff"..MS.idGuide.."|r");
	else
		GameTooltip:AddLine(core.L["ID Guide"]..core.L["2points"].."--");
	end
	GameTooltip:AddLine(core.L["Version"]..core.L["2points"].."|cffffffff"..MS.av_settings.version.."|r");
	if (MS.av_settings.createBy ~= nil and MS.av_settings.createBy ~= "") then
		GameTooltip:AddLine(core.L["Créé par"]..core.L["2points"].."|cffffffff"..MS.av_settings.createBy.."|r");
	else
		GameTooltip:AddLine(core.L["Créé par"]..core.L["2points"].."--");
	end
	if (MS.av_settings.lastModified ~= nil and MS.av_settings.lastModified ~= "") then
		GameTooltip:AddLine(core.L["Dernière modif"]..core.L["2points"].."|cffffffff"..MS.av_settings.lastModified.."|r");
	else
		GameTooltip:AddLine(core.L["Dernière modif"]..core.L["2points"].."--");
	end
	GameTooltip:AddLine(core.L["Langue"]..core.L["2points"].."|cffffffff"..core.L["LangSTR"][MS.lang[1]].."|r");
	GameTooltip:Show();
end


-- ======= TOOLTIP ID NPC/ITEM/QUEST/MOUNT/HF/TRANSMOG/PET on GameFrame =======
local WCC_tooltipInfoID = CreateFrame('GameTooltip', "WCC_tooltipInfoID", UIParent, 'GameTooltipTemplate')
	-- === NPC ===
local WCC_FrameDisplayID = CreateFrame("PlayerModel", "WCC_FrameDisplayID", UIParent);
local function OnTooltipGetDisplayID(self)
	if (TooltipIDShow == true) then
		local guid = UnitGUID("mouseover");
		if (guid ~= nil) then
			local typee, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
			if (npc_id ~= nil) then
				WCC_FrameDisplayID:SetCreature(npc_id);
				local displayID = WCC_FrameDisplayID:GetDisplayInfo();
				GameTooltip:AddLine("|cFFF5CC00"..core.L["DisplayID"]..core.L["2points"].."|r"..displayID, 1, 1, 1);
				GameTooltip:Show();
			end
		end
	end
end
GameTooltip:HookScript("OnTooltipSetUnit", OnTooltipGetDisplayID);

	-- === ITEM ===
local function OnTooltipGetItemID(self)
	if (TooltipIDShow == true) then
		local _, link = self:GetItem();
		local item = link or name;
		if (item ~= nil) then
			local itemID, _, _, _, icon = GetItemInfoInstant(item);
			if (itemID ~= nil) then
				GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Objet"]..core.L["2points"].."|r"..itemID, 1, 1, 1);
			end
			if (icon ~= nil) then
				GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Icon"]..core.L["2points"].."|r"..icon, 1, 1, 1);
			end
			GameTooltip:Show();
		end
	end
end
GameTooltip:HookScript("OnTooltipSetItem", OnTooltipGetItemID);

	-- === QUEST ===
local function OnEnterShowIdQuest(self, block)
	if (TooltipIDShow == true and block.id ~= nil) then
		local obj = block.HeaderText;
		GameTooltip:SetOwner(obj, "ANCHOR_NONE");
		local x, y = obj:GetCenter();
		local w = UIParent:GetWidth() / 3;
		if (x > w) then
			GameTooltip:SetPoint("TOPRIGHT", obj, "TOPLEFT", -6, 0);
		else
			GameTooltip:SetPoint("TOP", obj, "TOP", 0, 0);
			GameTooltip:SetPoint("LEFT", ObjectiveTrackerFrame, "RIGHT", -8, 0);
		end
		GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Quest"].."|r");
		GameTooltip:AddLine(block.id, 1, 1, 1);
		GameTooltip:Show();
	end
end
hooksecurefunc(CAMPAIGN_QUEST_TRACKER_MODULE, "OnBlockHeaderEnter", OnEnterShowIdQuest);
hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderEnter", OnEnterShowIdQuest);

	-- === WORLD QUEST ===
local function OnEnterShowIdWorldQuest(self, block)
	if (TooltipIDShow == true and block.id ~= nil) then
		WCC_tooltipInfoID:SetOwner(block, "ANCHOR_NONE");
		WCC_tooltipInfoID:SetPoint("TOPLEFT", GameTooltip, "BOTTOMLEFT", 0, 0);
		WCC_tooltipInfoID:AddLine("|cFFF5CC00"..core.L["ID Quest"].."|r");
		WCC_tooltipInfoID:AddLine(block.id, 1, 1, 1);
		WCC_tooltipInfoID:Show();
	end
end
hooksecurefunc(WORLD_QUEST_TRACKER_MODULE, "OnBlockHeaderLeave", function ()
	WCC_tooltipInfoID:Hide()
end);
hooksecurefunc(WORLD_QUEST_TRACKER_MODULE, "OnBlockHeaderEnter", OnEnterShowIdWorldQuest);

	-- === BONUS WOLRD QUEST ===
hooksecurefunc(BONUS_OBJECTIVE_TRACKER_MODULE, "OnBlockHeaderLeave", function ()
	WCC_tooltipInfoID:Hide()
end);
hooksecurefunc(BONUS_OBJECTIVE_TRACKER_MODULE, "OnBlockHeaderEnter", OnEnterShowIdWorldQuest);

	-- === HF ===
hooksecurefunc(ACHIEVEMENT_TRACKER_MODULE, "OnBlockHeaderLeave", WCCreator_Lib.tooltip.OnLeave);
hooksecurefunc(ACHIEVEMENT_TRACKER_MODULE, "OnBlockHeaderEnter", function(self, block)
	if (TooltipIDShow == true and block.id ~= nil) then
		local obj = block.HeaderText;
		GameTooltip:SetOwner(obj, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPRIGHT", obj, "TOPLEFT", -6, 0);
		GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Haut-fait"].."|r");
		GameTooltip:AddLine(block.id, 1, 1, 1);
		GameTooltip:Show();
	end
end);

	-- === MOUNT ===
local function OnTooltipGetSpellID(self)
	if (TooltipIDShow == true) then
		local spellName, spellID = GameTooltip:GetSpell()
		if (spellID ~= nil) then
			mountID = C_MountJournal.GetMountFromSpell(spellID)
			if (mountID ~= nil) then
				GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Monture"]..core.L["2points"].."|r"..mountID, 1, 1, 1);
				GameTooltip:Show();
			end
		end
	end
end
GameTooltip:HookScript("OnTooltipSetSpell", OnTooltipGetSpellID);

	-- === TRANSMOGS ===
local frameEventForTooltip_Transmog        = CreateFrame("Frame");
local frameEventForTooltip_Transmog_IsDone = false;
frameEventForTooltip_Transmog:RegisterEvent("TRANSMOG_SEARCH_UPDATED");
frameEventForTooltip_Transmog:SetScript("OnEvent", function(self, event, ...)
	if (TooltipIDShow == true and frameEventForTooltip_Transmog_IsDone == false and _G["WardrobeCollectionFrame"] ~= nil) then
		local modelsFrame = _G["WardrobeCollectionFrame"].ItemsCollectionFrame.Models;
		for i = 1, #modelsFrame do
			modelsFrame[i]:HookScript("OnEnter", function(self)
				if (self.visualInfo.uiOrder ~= nil) then
					local sourceID = self:GetParent():GetAnAppearanceSourceFromVisual(self.visualInfo.visualID, nil);
					local itemID   = C_Transmog.GetItemIDForSource(sourceID)
					WCC_tooltipInfoID:SetOwner(self, "ANCHOR_NONE");
					WCC_tooltipInfoID:SetPoint("TOPLEFT", GameTooltip, "BOTTOMLEFT", 0, 0);
					WCC_tooltipInfoID:ClearLines();
					WCC_tooltipInfoID:AddLine(core.L["ID Objet"]);
					WCC_tooltipInfoID:AddLine(itemID, 1, 1, 1);
					WCC_tooltipInfoID:Show();
				end	
			end)
			modelsFrame[i]:HookScript("OnLeave", function(self)
				WCC_tooltipInfoID:Hide();
			end)
		end
		frameEventForTooltip_Transmog_IsDone = true;
	end
end)

	-- === PETS ===
local frameEventForTooltip_Pets = CreateFrame("Frame");
local frameEventForTooltip_Pets_IsDone = false;
frameEventForTooltip_Pets:RegisterEvent("PET_JOURNAL_LIST_UPDATE");
frameEventForTooltip_Pets:SetScript("OnEvent", function(self, event, ...)
	if (TooltipIDShow == true and frameEventForTooltip_Pets_IsDone == false and _G["PetJournalListScrollFrameButton1"] ~= nil) then
		for i = 1, 11 do
			local petButton = _G["PetJournalListScrollFrameButton"..i];
			petButton.dragButton:HookScript("OnEnter", function(self)
				local petID   = select(11, C_PetJournal.GetPetInfoByIndex(petButton.index));
				GameTooltip:AddLine("|cFFF5CC00"..core.L["ID Mascotte"]..core.L["2points"].."|r"..petID, 1, 1, 1);
				GameTooltip:Show();
			end)
		end
		frameEventForTooltip_Pets_IsDone = true;
	end
end)
