local _, core = ...;
local MenuSettingsRens;

local function SaveRens()	
	local infoRens        = {};
	local settingsRens    = WCCreator_Lib.structures.SettingsRens_value;
	infoRens.category     = settingsRens.category;
	infoRens.displayID    = settingsRens.displayID;
	infoRens.title        = settingsRens.title;
	infoRens.stepAssigned = settingsRens.stepAssigned;
	infoRens.onMap        = {};
	infoRens.onMap.enable = settingsRens.onMap.enable;
	infoRens.onMap.pins   = settingsRens.onMap.pins;

	if (settingsRens.info.bIsNew == true) then
		table.insert(settingsRens.info.arrRens, settingsRens.info.idRens + 1, infoRens);
	else
		settingsRens.info.arrRens[settingsRens.info.idRens] = infoRens;
	end
	-- SHOW ON ACTUEL NEW CADRE
	local newIdRens = settingsRens.info.idRens;
	if (settingsRens.info.bIsNew == true) then
		newIdRens = newIdRens + 1;
	end
	WC_Lib.RefreshRens(newIdRens, settingsRens.info.arrRens, "WCC", settingsRens.info.idGuide, settingsRens.info.idPage)
	WCCreator_Lib.UpdateVersionGuide(nil,  settingsRens.info.idGuide);
	MenuSettingsRens:Hide();
	PlaySound("83", "sfx");
end

local function MenuSettingsRensFill(currentRens)
	local settingsRens = WCCreator_Lib.structures.SettingsRens_value;
	if (currentRens == nil) then
		settingsRens.category     = "NPC";
		settingsRens.displayID    = "";
		settingsRens.title        = "";
		settingsRens.stepAssigned = "";
		settingsRens.onMap.enable = false;
		settingsRens.onMap.pins   = {};
	else
		settingsRens.category     = currentRens.category;
		settingsRens.displayID    = currentRens.displayID;
		settingsRens.title        = currentRens.title;
		settingsRens.stepAssigned = currentRens.stepAssigned;
		settingsRens.onMap.enable = currentRens.onMap.enable;
		settingsRens.onMap.pins   = currentRens.onMap.pins;
	end
	MenuSettingsRens.tb_DisplayID:SetText(settingsRens.displayID);
	MenuSettingsRens.tb_FileID:SetText(settingsRens.displayID);
	MenuSettingsRens.tb_Title:SetText(settingsRens.title);
	MenuSettingsRens.tb_StepAssigned:SetText(settingsRens.stepAssigned);
	MenuSettingsRens.chbx_OnMap:SetChecked(settingsRens.onMap.enable);

	if (settingsRens.category == "NPC") then
		UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["PNJ"]);
		_G["WCC_textbox_SR_DisplayID"]:Show();
		_G["WCC_textbox_SR_FileID"]:Hide();
		_G["WCC_checkbox_SR_OnMap"]:Enable();
	elseif (settingsRens.category == "ENV") then
		UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["Environnement"]);
		_G["WCC_textbox_SR_DisplayID"]:Hide();
		_G["WCC_textbox_SR_FileID"]:Show();
		_G["WCC_checkbox_SR_OnMap"]:Enable();
	elseif (settingsRens.category == "ZONE") then
		UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["Zone"]);
		_G["WCC_textbox_SR_DisplayID"]:Hide();
		_G["WCC_textbox_SR_FileID"]:Hide();
		_G["WCC_checkbox_SR_OnMap"]:Disable();
	end
	
	_G["WCC_SR_AddPins_Btn"]:SetEnabled(MenuSettingsRens.chbx_OnMap:GetChecked());
	_G["WCC_checkbox_SR_FilPins_Btn"]:SetEnabled(MenuSettingsRens.chbx_OnMap:GetChecked());
	if (MenuSettingsRens.chbx_OnMap:GetChecked() == true) then
		WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionX"]);
		WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionY"]);
		WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_IDZone"]);
		_G["WCC_checkbox_SR_IsEntry"]:Enable();
	else
		WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_PositionX"]);
		WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_PositionY"]);
		WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_IDZone"]);
		_G["WCC_checkbox_SR_IsEntry"]:Disable();
	end
	_G["WCC_textbox_SR_PositionX"]:SetText("");
	_G["WCC_textbox_SR_PositionY"]:SetText("");
	_G["WCC_textbox_SR_IDZone"]:SetText("");
	_G["WCC_checkbox_SR_IsEntry"]:SetChecked(false);
	_G["WCC_SR_AddPins_Btn"]:Disable();
	
	if (#settingsRens.info.arrRens == 1) then
		MenuSettingsRens.DelBtn:Disable();
	else
		MenuSettingsRens.DelBtn:Enable();
	end
	MenuSettingsRens.ListPins.idGuide = settingsRens.info.idGuide;
	WCCreator_Lib.RefreshListOfItem(MenuSettingsRens.ListPins, WCCreator_Lib.structures.SettingsRens_value.onMap.pins, MenuSettingsRens.arrPins, {[1]="posX", [2]="posY", [3]="IDZone"});
end

local function CreateMenuSettingsRens(self)
	MenuSettingsRens = CreateFrame("Frame", "WCC_MenuSettingsRensFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate");
	MenuSettingsRens:SetSize(350,300);
	MenuSettingsRens:SetFrameLevel(504);
	MenuSettingsRens:SetMovable(true);
	MenuSettingsRens:EnableMouse(true);
	MenuSettingsRens:RegisterForDrag("LeftButton");
	MenuSettingsRens:SetScript("OnDragStart", MenuSettingsRens.StartMoving);
	MenuSettingsRens:SetScript("OnDragStop", MenuSettingsRens.StopMovingOrSizing);
	MenuSettingsRens:SetPoint("CENTER", UIParent, "CENTER");
	MenuSettingsRens:SetBackdrop({bgFile = "Interface/Collections/CollectionsBackgroundTile",
							edgeFile = "Interface/FriendsFrame/UI-Toast-Border",
							edgeSize = 16,
							insets = { left = 7, right = 5, top = 5, bottom = 6 }});
							
	MenuSettingsRens.close = CreateFrame("Button", nil, MenuSettingsRens, "UIPanelCloseButton");
	MenuSettingsRens.close:SetSize(32, 32);
	MenuSettingsRens.close:SetPoint("TOPRIGHT", MenuSettingsRens, "TOPRIGHT", -5, -5);
	MenuSettingsRens.close:SetScript("OnClick", function(self)
		MenuSettingsRens:Hide();
		PlaySound("854", "sfx");
	end);
	
	MenuSettingsRens.title = MenuSettingsRens:CreateFontString(nil, "OVERLAY", MenuSettingsRens);
	MenuSettingsRens.title:SetFontObject("GameFontHighlightLarge");
	MenuSettingsRens.title:SetText(core.L["Paramètres Cadre"]);
	MenuSettingsRens.title:SetPoint("TOP", MenuSettingsRens, "TOP", 0, -13);
	
	MenuSettingsRens.ddm_Category = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_Category, MenuSettingsRens);
	MenuSettingsRens.ddm_Category:SetPoint("TOPLEFT", MenuSettingsRens, "TOPLEFT", 0, -40);
	MenuSettingsRens.tb_DisplayID = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_DisplayID, MenuSettingsRens);
	MenuSettingsRens.tb_DisplayID:SetPoint("LEFT", MenuSettingsRens.ddm_Category, "RIGHT", 20, 0);
	MenuSettingsRens.tb_FileID = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_FileID, MenuSettingsRens);
	MenuSettingsRens.tb_FileID:SetPoint("LEFT", MenuSettingsRens.ddm_Category, "RIGHT", 20, 0);
	MenuSettingsRens.tb_FileID:Hide();
	MenuSettingsRens.tb_Title = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_Title, MenuSettingsRens);
	MenuSettingsRens.tb_Title:SetPoint("TOPLEFT", MenuSettingsRens.ddm_Category, "BOTTOMLEFT", 23, -35);
	MenuSettingsRens.tb_StepAssigned = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_StepAssigned, MenuSettingsRens);
	MenuSettingsRens.tb_StepAssigned:SetPoint("LEFT", MenuSettingsRens.tb_Title, "RIGHT", 10, 0);
	
	MenuSettingsRens.chbx_OnMap = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_OnMap, MenuSettingsRens);
	MenuSettingsRens.chbx_OnMap:SetPoint("TOPLEFT", MenuSettingsRens.tb_Title, "BOTTOMLEFT", -7, -12);
	MenuSettingsRens.tb_posX = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_PositionX, MenuSettingsRens);
	MenuSettingsRens.tb_posX:SetPoint("TOPLEFT", MenuSettingsRens.chbx_OnMap, "BOTTOMLEFT", 10, -12);
	WCCreator_Lib.TextBoxSetDisable(MenuSettingsRens.tb_posX);
	MenuSettingsRens.tb_posY = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_PositionY, MenuSettingsRens);
	MenuSettingsRens.tb_posY:SetPoint("LEFT", MenuSettingsRens.tb_posX, "RIGHT", 15, 0);
	WCCreator_Lib.TextBoxSetDisable(MenuSettingsRens.tb_posY);
	MenuSettingsRens.tb_IDZone = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_IDZone, MenuSettingsRens);
	MenuSettingsRens.tb_IDZone:SetPoint("LEFT", MenuSettingsRens.tb_posY, "RIGHT", 15, 0);
	WCCreator_Lib.TextBoxSetDisable(MenuSettingsRens.tb_IDZone);
	MenuSettingsRens.chbx_IsEntry = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SR_IsEntry, MenuSettingsRens);
	MenuSettingsRens.chbx_IsEntry:SetPoint("LEFT", MenuSettingsRens.tb_IDZone, "RIGHT", 5, 0);
	MenuSettingsRens.chbx_IsEntry:Disable();
	
	MenuSettingsRens.AddPins = CreateFrame("Button", "WCC_SR_AddPins_Btn", MenuSettingsRens, "UIPanelButtonTemplate");
	MenuSettingsRens.AddPins:SetSize(75, 25);
	MenuSettingsRens.AddPins:SetText(core.L["Ajouter"]);
	MenuSettingsRens.AddPins:Disable();
	MenuSettingsRens.AddPins:SetPoint("TOPLEFT", MenuSettingsRens.tb_posX, "BOTTOMLEFT", -6, 0);
	MenuSettingsRens.AddPins:SetScript("OnClick", function(self)
		local arrPos = #WCCreator_Lib.structures.SettingsRens_value.onMap.pins + 1;
		WCCreator_Lib.structures.SettingsRens_value.onMap.pins[arrPos]         = {};
		WCCreator_Lib.structures.SettingsRens_value.onMap.pins[arrPos].posX    = MenuSettingsRens.tb_posX:GetText();
		WCCreator_Lib.structures.SettingsRens_value.onMap.pins[arrPos].posY    = MenuSettingsRens.tb_posY:GetText();
		WCCreator_Lib.structures.SettingsRens_value.onMap.pins[arrPos].IDZone  = MenuSettingsRens.tb_IDZone:GetText();
		WCCreator_Lib.structures.SettingsRens_value.onMap.pins[arrPos].IsEntry = MenuSettingsRens.chbx_IsEntry:GetChecked();
		WCCreator_Lib.RefreshListOfItem(MenuSettingsRens.ListPins, WCCreator_Lib.structures.SettingsRens_value.onMap.pins, MenuSettingsRens.arrPins, {[1]="posX", [2]="posY", [3]="IDZone"});
		WCCreator_Lib.UpdateVersionGuide(nil, WCCreator_Lib.structures.SettingsRens_value.info.idGuide);
		PlaySound("83", "sfx");
	end);
	MenuSettingsRens.FillOnMap = CreateFrame("Button", "WCC_checkbox_SR_FilPins_Btn", MenuSettingsRens, "UIPanelButtonTemplate");
	MenuSettingsRens.FillOnMap:SetSize(75, 25);
	MenuSettingsRens.FillOnMap:SetText(core.L["Remplir"]);
	MenuSettingsRens.FillOnMap:Disable();
	MenuSettingsRens.FillOnMap:SetPoint("LEFT", MenuSettingsRens.AddPins, "RIGHT", 5, 0);
	MenuSettingsRens.FillOnMap:SetScript("OnLeave", WC_Lib.OnLeave);
	MenuSettingsRens.FillOnMap:SetScript("OnClick", function(self)
		uiMapID = C_Map.GetBestMapForUnit("player");
		if (uiMapID) then
			MenuSettingsRens.tb_IDZone:SetText(uiMapID);
			local position = C_Map.GetPlayerMapPosition(uiMapID, "player");
			if (position ~= nil) then
				local posX, posY = position:GetXY();
				posX = posX*10000;
				posX = math.floor(posX);
				posX = posX/100;
				MenuSettingsRens.tb_posX:SetText(posX);
				posY = posY*10000;
				posY = math.floor(posY);
				posY = posY/100;
				MenuSettingsRens.tb_posY:SetText(posY);
			else
				MenuSettingsRens.tb_posX:SetText("");
				MenuSettingsRens.tb_posY:SetText("");
			end
			PlaySound("83", "sfx");
		end
	end);
	MenuSettingsRens.FillOnMap:SetScript("OnEnter", function(self) GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 0, 0);
		GameTooltip:AddLine(core.L["Remplir"], 1, 1, 1);
		GameTooltip:AddLine(core.L["Complète les coordonnées avec votre position actuelle"]);
		GameTooltip:Show();
	end);

	MenuSettingsRens.ListPins = CreateFrame("Frame", "WCC_MenuSettingsRensFrame_ListPins", MenuSettingsRens, BackdropTemplateMixin and "BackdropTemplate");
	MenuSettingsRens.ListPins:SetSize(MenuSettingsRens:GetWidth()-40, 25);
	MenuSettingsRens.ListPins:SetPoint("TOPLEFT", MenuSettingsRens.tb_posX, "BOTTOMLEFT", 0, -40);
	MenuSettingsRens.ListPins:SetScript("OnSizeChanged", function (self, width, height)
		MenuSettingsRens:SetSize(350, 300 + MenuSettingsRens.ListPins:GetHeight());
	end);
	MenuSettingsRens.ListPins:SetBackdrop({bgFile = ""}); -- <= Obligé sinon ne s'affiche pas
							
	MenuSettingsRens.AddBtn = CreateFrame("Button", nil, MenuSettingsRens, "UIPanelButtonTemplate");
	MenuSettingsRens.AddBtn:SetSize(100, 25);
	MenuSettingsRens.AddBtn:SetText(core.L["Ajouter"]);
	MenuSettingsRens.AddBtn:SetPoint("BOTTOM", MenuSettingsRens, "BOTTOM", 0, 10);
	MenuSettingsRens.AddBtn:SetScript("OnClick", SaveRens);
	
	MenuSettingsRens.DelBtn = CreateFrame("Button", nil, MenuSettingsRens, "UIPanelButtonTemplate");
	MenuSettingsRens.DelBtn:SetSize(100, 25);
	MenuSettingsRens.DelBtn:SetText(core.L["Supprimer"]);
	MenuSettingsRens.DelBtn:SetPoint("LEFT", MenuSettingsRens.AddBtn, "RIGHT", 0, 0);
	MenuSettingsRens.DelBtn:SetScript("OnClick", function(self)
		local bMinus = 0;
		if (WCCreator_Lib.structures.SettingsRens_value.info.idRens == #WCCreator_Lib.structures.SettingsRens_value.info.arrRens and WCCreator_Lib.structures.SettingsRens_value.info.idRens > 1) then
			bMinus = 1;
		end
		table.remove(WCCreator_Lib.structures.SettingsRens_value.info.arrRens, WCCreator_Lib.structures.SettingsRens_value.info.idRens);
		WC_Lib.RefreshRens(WCCreator_Lib.structures.SettingsRens_value.info.idRens - bMinus, WCCreator_Lib.structures.SettingsRens_value.info.arrRens, "WCC", WCCreator_Lib.structures.SettingsRens_value.info.idGuide, WCCreator_Lib.structures.SettingsRens_value.info.idPage)
		WCCreator_Lib.UpdateVersionGuide(nil,  WCCreator_Lib.structures.SettingsRens_value.info.idGuide);
		PlaySound("882", "sfx");
		MenuSettingsRens:Hide();
	end);
	
	MenuSettingsRens:Hide();
	MenuSettingsRens.arrPins = {};
	return MenuSettingsRens;
end

function WCCreator_Lib.ToggleSettingsRens(self)
	local settingsRens = MenuSettingsRens or CreateMenuSettingsRens(self);
	if (not settingsRens:IsShown()) then
		WCCreator_Lib.structures.SettingsRens_value.info.bIsNew     = self.bIsNew;
		WCCreator_Lib.structures.SettingsRens_value.info.idRens     = self.idRens;
		WCCreator_Lib.structures.SettingsRens_value.info.idPage     = self.idPage;
		WCCreator_Lib.structures.SettingsRens_value.info.idGuide    = self.idGuide;
		WCCreator_Lib.structures.SettingsRens_value.info.arrRens    = self.arrRens;
		--WCCreator_Lib.structures.SettingsRens_value.info.parentName = self.parentName;
		if (self.bIsNew == true) then
			MenuSettingsRensFill(nil);
			settingsRens.title:SetText(core.L["Nouveau cadre"]);
			settingsRens.AddBtn:SetText(core.L["Ajouter"]);
			settingsRens.AddBtn:SetPoint("BOTTOM", settingsRens, "BOTTOM", 0, 10);
			settingsRens.DelBtn:Hide();
		else
			MenuSettingsRensFill(self.arrRens[self.idRens]);
			settingsRens.title:SetText(core.L["Paramètres Cadre"]);
			settingsRens.AddBtn:SetText(core.L["Sauvegarder"]);
			settingsRens.AddBtn:SetPoint("BOTTOM", settingsRens, "BOTTOM", -55, 10);
			settingsRens.DelBtn:SetPoint("LEFT", settingsRens.AddBtn, "RIGHT", 0, 0);
			settingsRens.DelBtn:Show();
		end
		settingsRens:Show();
		PlaySound("681", "sfx");
	end
end