local _, core = ...;
local MenuSettingsStep;

local function SaveStep()
	local arrSteps = WCCreator_Lib.structures.SettingsStep_value.info.arrSteps;
	arrSteps[WCCreator_Lib.structures.SettingsStep_value.info.idStep].help      = WCCreator_Lib.structures.SettingsStep_value.help;
	arrSteps[WCCreator_Lib.structures.SettingsStep_value.info.idStep].important = WCCreator_Lib.structures.SettingsStep_value.important;
	arrSteps[WCCreator_Lib.structures.SettingsStep_value.info.idStep].task      = WCCreator_Lib.structures.SettingsStep_value.task;
	
	WC_Lib.RefreshPageSteps(arrSteps, "WCC", WCCreator_Lib.structures.SettingsStep_value.info.idGuide, WCCreator_Lib.structures.SettingsStep_value.info.idPage)
	
	WCCreator_Lib.UpdateVersionGuide(nil, WCCreator_Lib.structures.SettingsStep_value.info.idGuide);
	MenuSettingsStep:Hide();
	PlaySound("83", "sfx");
end

local function ReturnArrayTitle(arrTitle)
	local arr = {};
	for i = 1, #arrTitle do
		arr[i] = {arrTitle[i].title};
	end
	return arr;
end

local function MenuSettingsStepFill(currentStep)
	WCCreator_Lib.structures.SettingsStep_value.help      = currentStep.help;
	WCCreator_Lib.structures.SettingsStep_value.important = currentStep.important;
	WCCreator_Lib.structures.SettingsStep_value.task      = currentStep.task;
	_G["WCC_multiline_SS_Help"]:SetText(currentStep.help);
	MenuSettingsStep.chbx_Important:SetChecked(currentStep.important);
	MenuSettingsStep.ListTask.idGuide = WCCreator_Lib.structures.SettingsStep_value.info.idGuide;
	WCCreator_Lib.RefreshListOfItem(MenuSettingsStep.ListTask, WCCreator_Lib.structures.SettingsStep_value.task, MenuSettingsStep.arrTask, {[1] = "title"}, 1,
		function ()
			WC_Lib.RefreshPageSteps(WCCreator_Lib.structures.SettingsStep_value.info.arrSteps, "WCC", WCCreator_Lib.structures.SettingsStep_value.info.idGuide, WCCreator_Lib.structures.SettingsStep_value.info.idPage);
		end);
end

local function CreateMenuSettingsStep(self)
	MenuSettingsStep = CreateFrame("Frame", "WCC_MenuSettingsStepFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate");
	MenuSettingsStep:SetSize(400, 320);
	MenuSettingsStep:SetFrameLevel(509);
	MenuSettingsStep:SetMovable(true);
	MenuSettingsStep:EnableMouse(true);
	MenuSettingsStep:RegisterForDrag("LeftButton");
	MenuSettingsStep:SetScript("OnDragStart", MenuSettingsStep.StartMoving);
	MenuSettingsStep:SetScript("OnDragStop", MenuSettingsStep.StopMovingOrSizing);
	MenuSettingsStep:SetPoint("CENTER", UIParent, "CENTER");
	MenuSettingsStep:SetBackdrop({bgFile = "Interface/Collections/CollectionsBackgroundTile",
							edgeFile = "Interface/FriendsFrame/UI-Toast-Border",
							edgeSize = 16,
							insets = { left = 7, right = 5, top = 5, bottom = 6 }});
							
	MenuSettingsStep.close = CreateFrame("Button", nil, MenuSettingsStep, "UIPanelCloseButton");
	MenuSettingsStep.close:SetSize(32, 32);
	MenuSettingsStep.close:SetPoint("TOPRIGHT", MenuSettingsStep, "TOPRIGHT", -5, -5);
	MenuSettingsStep.close:SetScript("OnClick", function(self)
		MenuSettingsStep:Hide();
		PlaySound("854", "sfx");
	end);
	
	MenuSettingsStep.title = MenuSettingsStep:CreateFontString(nil, "OVERLAY", MenuSettingsStep);
	MenuSettingsStep.title:SetFontObject("GameFontHighlightLarge");
	MenuSettingsStep.title:SetText(core.L["Paramètres Étape"]);
	MenuSettingsStep.title:SetPoint("TOP", MenuSettingsStep, "TOP", 0, -13);
	
	
	MenuSettingsStep.subtitle1 = WCCreator_Lib.CreateTitle(core.L["Général"], MenuSettingsStep);
	MenuSettingsStep.subtitle1:SetPoint("TOP", MenuSettingsStep.title, "BOTTOM", 0, -15);
	
	MenuSettingsStep.multi_Help = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SS_Help, MenuSettingsStep);
	MenuSettingsStep.multi_Help:SetPoint("TOP", MenuSettingsStep.subtitle1, "BOTTOM", -10, -22);
	
	MenuSettingsStep.chbx_Important = WCCreator_Lib.CreateCustomFrame(WCCreator_Lib.structures.SS_Important, MenuSettingsStep);
	MenuSettingsStep.chbx_Important:SetPoint("TOPLEFT", MenuSettingsStep.multi_Help, "BOTTOMLEFT", -3, -7);
	
	MenuSettingsStep.subtitle2 = WCCreator_Lib.CreateTitle(core.L["Tâche(s)"], MenuSettingsStep);
	MenuSettingsStep.subtitle2:SetPoint("TOP", MenuSettingsStep.subtitle1, "BOTTOM", 0, -(MenuSettingsStep.multi_Help:GetHeight() + 60));
	
	MenuSettingsStep.ListTask = CreateFrame("Frame", "WCC_MenuSettingsStepFrame_ListTask", MenuSettingsStep, BackdropTemplateMixin and "BackdropTemplate");
	MenuSettingsStep.ListTask:SetSize(MenuSettingsStep:GetWidth()-40, 25);
	MenuSettingsStep.ListTask:SetPoint("TOPLEFT", MenuSettingsStep.subtitle2, "BOTTOMLEFT", 20, -10);
	MenuSettingsStep.ListTask:SetScript("OnSizeChanged", function (self, width, height)
		MenuSettingsStep:SetSize(400, 320 + MenuSettingsStep.ListTask:GetHeight());
	end);
	MenuSettingsStep.ListTask:SetBackdrop({bgFile = ""}); -- <= Obligé sinon ne s'affiche pas
	
	MenuSettingsStep.NewTaskBtn = CreateFrame("Button", nil, MenuSettingsStep, "UIPanelButtonTemplate");
	MenuSettingsStep.NewTaskBtn:SetSize(120, 25);
	MenuSettingsStep.NewTaskBtn:SetText(core.L["Nouvelle tâche"]);
	MenuSettingsStep.NewTaskBtn:SetPoint("TOP", MenuSettingsStep.ListTask, "BOTTOM", 0, 0);
	MenuSettingsStep.NewTaskBtn:SetScript("OnClick", function(self)
		local arrPos = #WCCreator_Lib.structures.SettingsStep_value.task + 1;
		WCCreator_Lib.structures.SettingsStep_value.task[arrPos] = {taskType = "custom", title = core.L["Titre quête"], tooltipText = core.L["Description quête"]};
		WCCreator_Lib.RefreshListOfItem(MenuSettingsStep.ListTask, WCCreator_Lib.structures.SettingsStep_value.task, MenuSettingsStep.arrTask, {[1] = "title"}, 1,
			function ()
				WC_Lib.RefreshPageSteps(WCCreator_Lib.structures.SettingsStep_value.info.arrSteps, "WCC", WCCreator_Lib.structures.SettingsStep_value.info.idGuide, WCCreator_Lib.structures.SettingsStep_value.info.idPage);
			end);
		WC_Lib.RefreshPageSteps(WCCreator_Lib.structures.SettingsStep_value.info.arrSteps, "WCC", WCCreator_Lib.structures.SettingsStep_value.info.idGuide, WCCreator_Lib.structures.SettingsStep_value.info.idPage);
		WCCreator_Lib.UpdateVersionGuide(nil, WCCreator_Lib.structures.SettingsStep_value.info.idGuide);
		PlaySound("83", "sfx");
	end);
	
	MenuSettingsStep.SaveBtn = CreateFrame("Button", nil, MenuSettingsStep, "UIPanelButtonTemplate");
	MenuSettingsStep.SaveBtn:SetSize(100, 25);
	MenuSettingsStep.SaveBtn:SetText(core.L["Sauvegarder"]);
	MenuSettingsStep.SaveBtn:SetPoint("BOTTOM", MenuSettingsStep, "BOTTOM", -55, 10);
	MenuSettingsStep.SaveBtn:SetScript("OnClick", SaveStep);
	
	MenuSettingsStep.DelBtn = CreateFrame("Button", nil, MenuSettingsStep, "UIPanelButtonTemplate");
	MenuSettingsStep.DelBtn:SetSize(100, 25);
	MenuSettingsStep.DelBtn:SetText(core.L["Supprimer"]);
	MenuSettingsStep.DelBtn:SetPoint("LEFT", MenuSettingsStep.SaveBtn, "RIGHT", 0, 0);
	MenuSettingsStep.DelBtn:SetScript("OnClick", function(self)
		table.remove(WCCreator_Lib.structures.SettingsStep_value.info.arrSteps, WCCreator_Lib.structures.SettingsStep_value.info.idStep);
		WC_Lib.RefreshPageSteps(WCCreator_Lib.structures.SettingsStep_value.info.arrSteps, "WCC", WCCreator_Lib.structures.SettingsStep_value.info.idGuide, WCCreator_Lib.structures.SettingsStep_value.info.idPage);
		WCCreator_Lib.UpdateVersionGuide(nil, WCCreator_Lib.structures.SettingsStep_value.info.idGuide);
		PlaySound("882", "sfx");
		MenuSettingsStep:Hide();
	end);
	MenuSettingsStep.arrTask = {};
	MenuSettingsStep:Hide();
	return MenuSettingsStep;
end

function WCCreator_Lib.ToggleSettingsStep(self)
	local settingsStep = MenuSettingsStep or CreateMenuSettingsStep(self);
	if (not settingsStep:IsShown()) then
		WCCreator_Lib.structures.SettingsStep_value.info.idStep   = self.idStep;
		WCCreator_Lib.structures.SettingsStep_value.info.idPage   = self.idPage;
		WCCreator_Lib.structures.SettingsStep_value.info.idGuide  = self.idGuide;
		WCCreator_Lib.structures.SettingsStep_value.info.arrSteps = self.arrSteps;
		MenuSettingsStepFill(self.arrSteps[self.idStep]);	
		if (#self.arrSteps == 1) then
			MenuSettingsStep.DelBtn:Disable();
		else
			MenuSettingsStep.DelBtn:Enable();
		end
		settingsStep:Show();
		PlaySound("681", "sfx");
	end
end