local _, core = ...;
WCCreator_Lib.structures = {};

WCCreator_Lib.structures.CurrentFilters = {true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true}; -- Obtenu, Manquant, HF, Mount, Pet, Transmog, Easy, Medium, Hard, Neutral, Ally, Horde, Classic, BC, WOTLK, Cata, MOP, WOD, Legion, BFA, Shadow

WCCreator_Lib.structures.MainSettings_value = {
	category = "hf",
	idGuide = "",
	id = "",
	iconID = 134400,
	name = core.L["Nouveau guide"],
	description = "",
	location = "",
	displayID = 0,
	modID = 0,
	bOnPlayer = false,
	faction = 3,
	expansion = "",
	difficulty = 1,
	isCollected = false,
	class = {true, true, true, true, true, true, true, true, true, true, true, true},
	lang = {1, 2},
	av_settings = {version = 1, createBy = "", lastModified = ""}
};

----- TEXTBOX -----
WCCreator_Lib.structures.MS_IdAchiev = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Haut-fait"],
	frameTitle = "MS_IdAchiev",
	desc = core.L["Rentrez l'ID du haut-fait dont vous voulez faire un guide"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.id = _G["WCC_textbox_MS_IdAchiev"]:GetText();
			end	
		},
	},
	button = {
		title = core.L["Valider"],
		desc  = core.L["Complète les informations textuelles et graphiques grâce à l'ID ci-dessus"],
		width = 70,
		func = function (self)
			local hfID = self:GetParent():GetText();
			if (hfID ~= "" and hfID ~= nil and tonumber(hfID) < 2147483647) then
				local infoHF = {GetAchievementInfo(tonumber(hfID))};
				if (infoHF[2] ~= nil) then
					_G["WCC_textbox_MS_Name"]:SetText(infoHF[2]);
					_G["WCC_multiline_MS_Desc"]:SetText(infoHF[8]);
					_G["WCC_multiline_MS_Location"]:SetText(WC_Lib.GetInfoHFCriteria(infoHF[1], 1));
					_G["WCC_textbox_MS_DisplayID"]:SetText("");
					_G["WCC_MS_PreviewIcon"]:SetBackdrop({bgFile = infoHF[10]});
					WCCreator_Lib.structures.MainSettings_value.isCollected = infoHF[4];
					WCCreator_Lib.structures.MainSettings_value.iconID = infoHF[10];
					if (WCCreator_Lib.structures.MainSettings_value.isCollected == true) then
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontGreen");
					else
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontNormal");
					end
					_G["WCC_MS_GuideIconInteract"]:SetBackdrop({
						bgFile = infoHF[10],
						insets = { left = 3, right = 2, top = 3, bottom = 2 }});
					WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdAchiev", false);
					UIDropDownMenu_DisableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
					PlaySound("83", "sfx");
				else
					UIErrorsFrame:AddMessage(core.L["ErrorNoFindID"], 1, 0, 0);
					PlaySound("47355", "sfx", true);
				end
			end
		end
	},
};

WCCreator_Lib.structures.MS_IdAchievValid = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Haut-fait"],
	frameTitle = "MS_IdAchievValid",
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdAchiev", true);
			UIDropDownMenu_EnableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.MS_IdMounts = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Monture"],
	frameTitle = "MS_IdMounts",
	desc = core.L["Rentrez l'ID de la monture dont vous voulez faire un guide"],
	nbOnly = true,
	button = {
		title = core.L["Valider"],
		desc  = core.L["Complète les informations textuelles et graphiques grâce à l'ID ci-dessus"],
		width = 70,
		func = function (self)
			local itemID = self:GetParent():GetText();
			if (itemID ~= "" and itemID ~= nil and tonumber(itemID) < 2147483647) then
				local mountMainInfo  = {C_MountJournal.GetMountInfoByID(itemID)};
				if (mountMainInfo[1] ~= nil) then
					WCCreator_Lib.structures.MainSettings_value.id = itemID;
					local mountExtraInfo = {C_MountJournal.GetMountInfoExtraByID(itemID)};
					_G["WCC_textbox_MS_Name"]:SetText(mountMainInfo[1]);
					_G["WCC_textbox_MS_DisplayID"]:SetText(mountExtraInfo[1]);
					_G["WCC_multiline_MS_Desc"]:SetText(mountExtraInfo[2]);
					_G["WCC_multiline_MS_Location"]:SetText(mountExtraInfo[3]);
					_G["WCC_MS_PreviewIcon"]:SetBackdrop({bgFile = mountMainInfo[3]});
					WCCreator_Lib.structures.MainSettings_value.iconID = mountMainInfo[3];
					_G["WCC_MS_GuideIconInteract"]:SetBackdrop({
						bgFile = mountMainInfo[3],
						insets = { left = 3, right = 2, top = 3, bottom = 2 }});
					if (mountMainInfo[9] == 0) then
						WCCreator_Lib.structures.MainSettings_value.faction = 2;
						UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r "..core.L["Horde"]);
						_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallenger/images/mounts/button_bg_horde"});
					elseif(mountMainInfo[9] == 1) then
						WCCreator_Lib.structures.MainSettings_value.faction = 1;
						UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r "..core.L["Alliance"]);
						_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallenger/images/mounts/button_bg_alliance"});
					else
						WCCreator_Lib.structures.MainSettings_value.faction = 3;
						UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r "..core.L["Neutre"]);
						_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = ""});
					end
					WCCreator_Lib.structures.MainSettings_value.isCollected = mountMainInfo[11];
					if (WCCreator_Lib.structures.MainSettings_value.isCollected == true) then
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontGreen");
					else
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontNormal");
					end
					WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdMounts", false);
					UIDropDownMenu_DisableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
					PlaySound("83", "sfx");
				else
					UIErrorsFrame:AddMessage(core.L["ErrorNoFindID"], 1, 0, 0);
					PlaySound("47355", "sfx", true);
				end
			end
		end
	},
};

WCCreator_Lib.structures.MS_IdMountsValid = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Monture"],
	frameTitle = "MS_IdMountsValid",
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdMounts", true);
			UIDropDownMenu_EnableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.MS_IdPets = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Mascotte"],
	frameTitle = "MS_IdPets",
	desc = core.L["Rentrez l'ID de la mascotte dont vous voulez faire un guide"],
	nbOnly = true,
	button = {
		title = core.L["Valider"],
		desc  = core.L["Complète les informations textuelles et graphiques grâce à l'ID ci-dessus"],
		width = 70,
		func = function (self)
			local petID = self:GetParent():GetText();
			if (petID ~= "" and petID ~= nil and tonumber(petID) < 2147483647) then
				local petInfo = WC_Lib.getPetInfoById(petID);
				if (petInfo ~= nil) then
					WCCreator_Lib.structures.MainSettings_value.id = petID;
					_G["WCC_textbox_MS_Name"]:SetText(petInfo[8]);
					local _, _, _, _, _, _, _, _, _, _, _, displayID = C_PetJournal.GetPetInfoBySpeciesID(petInfo[2]);
					_G["WCC_textbox_MS_DisplayID"]:SetText(tostring(displayID));
					_G["WCC_multiline_MS_Desc"]:SetText(petInfo[13]);
					_G["WCC_multiline_MS_Location"]:SetText(petInfo[12]);
					_G["WCC_MS_PreviewIcon"]:SetBackdrop({bgFile = petInfo[9]});
					_G["WCC_MS_GuideIconInteract"]:SetBackdrop({
						bgFile = petInfo[9],
						insets = { left = 3, right = 2, top = 3, bottom = 2 }});
					WCCreator_Lib.structures.MainSettings_value.isCollected = petInfo[3];
					WCCreator_Lib.structures.MainSettings_value.iconID = petInfo[9];
					if (WCCreator_Lib.structures.MainSettings_value.isCollected == true) then
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontGreen");
					else
						_G["WCC_MS_PreviewText"]:SetFontObject("GameFontNormal");
					end
					WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdPets", false);
					UIDropDownMenu_DisableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
					PlaySound("83", "sfx");
				else
					UIErrorsFrame:AddMessage(core.L["ErrorNoFindID"], 1, 0, 0);
					PlaySound("47355", "sfx", true);
				end
			end
		end
	},
};

WCCreator_Lib.structures.MS_IdPetsValid = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Mascotte"],
	frameTitle = "MS_IdPetsValid",
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdPets", true);
			UIDropDownMenu_EnableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.MS_IdTransmogs = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Objet"],
	frameTitle = "MS_IdTransmogs",
	desc = core.L["Rentrez l'ID de l'apparence dont vous voulez faire un guide"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.id = _G["WCC_textbox_MS_IdTransmogs"]:GetText();
			end	
		},
	},
	button = {
		title = core.L["Valider"],
		desc  = core.L["Complète les informations textuelles et graphiques grâce à l'ID ci-dessus"],
		width = 70,
		func = function (self)
			local transmogID = self:GetParent():GetText();
			if (transmogID ~= "" and transmogID ~= nil and tonumber(transmogID) < 2147483647) then
				_G["WCC_textbox_MS_IdTransmogsBtn"]:Disable();
				local item = Item:CreateFromItemID(tonumber(transmogID));
				local isEmpty = item:IsItemEmpty();
				if (isEmpty == false) then
					item:ContinueOnItemLoad(function()
						local isDressableItem = C_Item.IsDressableItemByID(transmogID);
						if (isDressableItem == true) then
							local itemName, _, _, _, _, itemType, itemSubType, _, itemEquipLoc, itemIcon, _, itemTypeID, itemSubTypeID  = GetItemInfo(tonumber(transmogID));
							if (itemTypeID ~= 2 and itemEquipLoc ~= "INVTYPE_HEAD" and itemEquipLoc ~= "INVTYPE_SHOULDER"
							and itemEquipLoc ~= "INVTYPE_SHIELD" and itemEquipLoc ~= "INVTYPE_HOLDABLE") then
								WCCreator_Lib.structures.MainSettings_value.bOnPlayer = true;
							else
								WCCreator_Lib.structures.MainSettings_value.bOnPlayer = false;
							end
							_G["WCC_textbox_MS_Name"]:SetText(itemName);
							_G["WCC_multiline_MS_Desc"]:SetText("");
							_G["WCC_multiline_MS_Location"]:SetText("|cFFF5CC00"..core.L["Emplacement"]..core.L["2points"].."|r".._G[itemEquipLoc].."\n|cFFF5CC00"..core.L["Type"]..core.L["2points"].."|r"..GetItemSubClassInfo(itemTypeID, itemSubTypeID));
							_G["WCC_textbox_MS_ModID"]:SetText("");
							_G["WCC_textbox_MS_ModID"]:SetText("0");
							WCCreator_Lib.structures.MainSettings_value.iconID = itemIcon;
							_G["WCC_MS_PreviewIcon"]:SetBackdrop({bgFile = itemIcon});
							_G["WCC_MS_GuideIconInteract"]:SetBackdrop({
								bgFile = itemIcon,
								insets = { left = 3, right = 2, top = 3, bottom = 2 }});
							_G["WCC_textbox_MS_IdTransmogsBtn"]:Enable();
							WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdTransmogs", false);
							UIDropDownMenu_DisableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
							PlaySound("83", "sfx");
						else
							UIErrorsFrame:AddMessage(core.L["Cet objet ne peut pas être transmogrifié."], 1, 0, 0);
							PlaySound("47355", "sfx", true);
							_G["WCC_textbox_MS_IdTransmogsBtn"]:Enable();
						end
					end)
				else
					UIErrorsFrame:AddMessage(core.L["ErrorNoFindID"], 1, 0, 0);
					PlaySound("47355", "sfx", true);
					_G["WCC_textbox_MS_IdTransmogsBtn"]:Enable();
				end
			end
		end
	},
};

WCCreator_Lib.structures.MS_IdTransmogsValid = {
	frameType = "textbox",
	width = 175,
	title = core.L["ID Objet"],
	frameTitle = "MS_IdTransmogsValid",
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_MS_IdTransmogs", true);
			UIDropDownMenu_EnableDropDown(_G["WCC_dropdownmenu_MS_Category"]) 
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.MS_Name = {
	frameType = "textbox",
	width = 450,
	title = core.L["Nom"],
	frameTitle = "MS_Name",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.name = _G["WCC_textbox_MS_Name"]:GetText();
				_G["WCC_MS_PreviewText"]:SetText(WCCreator_Lib.structures.MainSettings_value.name);
			end	
		},
	}
};

WCCreator_Lib.structures.MS_DisplayID = {
	frameType = "textbox",
	width = 175,
	title = core.L["DisplayID"],
	frameTitle = "MS_DisplayID",
	desc = core.L["Correspond à l'ID du model 3D"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.displayID = _G["WCC_textbox_MS_DisplayID"]:GetText();
			end	
		},
	},
	button = {
		title = core.L["Aperçu"],
		desc = core.L["Aperçu visuel du model 3D"],
		width = 70,
		func = function (self)
			WCCreator_Lib.ShowPopupModelView(WCCreator_Lib.structures.MainSettings_value.category,
												 WCCreator_Lib.structures.MainSettings_value.displayID,
												 WCCreator_Lib.structures.MainSettings_value.modID);
		end
	},
};

WCCreator_Lib.structures.MS_ModID = {
	frameType = "textbox",
	width = 175,
	title = core.L["ModID"],
	frameTitle = "MS_ModID",
	desc = core.L["Correspond à des variations d'apparences de l'objet de base (uniquement lorsque l'objet possède plusieurs apparences)"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local modID = _G["WCC_textbox_MS_ModID"]:GetText();
				if (modID ~= nil and modID ~= "") then
					WCCreator_Lib.structures.MainSettings_value.modID = modID;
					local idItem = WCCreator_Lib.structures.MainSettings_value.id;
					if (tonumber(modID) < 2147483647 and (idItem ~= nil and idItem ~= "" and tonumber(idItem) < 2147483647)) then
						local isCollected = C_TransmogCollection.PlayerHasTransmog(WCCreator_Lib.structures.MainSettings_value.id , modID);
						WCCreator_Lib.structures.MainSettings_value.isCollected = isCollected;
						if (isCollected == true) then
							_G["WCC_MS_PreviewText"]:SetFontObject("GameFontGreen");
						else
							_G["WCC_MS_PreviewText"]:SetFontObject("GameFontNormal");
						end
					end
				end
			end	
		},
	},
	button = {
		title = core.L["Voir liste"],
		desc = core.L["Voir une liste de variation d'apparence de l'objet."],
		width = 70,
		func = function (self)
			local modID = _G["WCC_textbox_MS_ModID"]:GetText();
			if (modID ~= nil and modID ~= "") then
				WCCreator_Lib.ShowListVariationModelView(WCCreator_Lib.structures.MainSettings_value.id, WCCreator_Lib.structures.MainSettings_value.bOnPlayer);
			end
		end
	},
};
----- MULTILINE -----
WCCreator_Lib.structures.MS_Desc = {
	frameType = "multiline",
	width = 185,
	height = 80,
	title = core.L["Description"],
	frameTitle = "MS_Desc",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.description = _G["WCC_multiline_MS_Desc"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.MS_Location = {
	frameType = "multiline",
	width = 185,
	height = 80,
	title = core.L["Obtention"],
	frameTitle = "MS_Location",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.MainSettings_value.location = _G["WCC_multiline_MS_Location"]:GetText();
			end	
		},
	}
};

----- ICON SELECTOR -----
WCCreator_Lib.structures.iconSelectorGuide = {
	func = function (self)
		WCCreator_Lib.structures.MainSettings_value.iconID = self.iconSelected;
		_G["WCC_MS_GuideIconInteract"]:SetBackdrop({
			bgFile = self.iconSelected,
			insets = { left = 3, right = 2, top = 3, bottom = 2 }});
		_G["WCC_MS_PreviewIcon"]:SetBackdrop({
			bgFile = self.iconSelected});
		_G["WCC_ListIconSelectorFrameIcon"]:Hide();
		PlaySound("83", "sfx");
	end
};

----- DROPDOWN MENU -----
WCCreator_Lib.structures.WCCFilterMenu = {
	frameOwner = nil;
	info = {
		{   text = core.L["MountCollected"],
			arg1 = core.L["MountCollected"],
			isNotRadio       = true,
			disabled         = false,
			keepShownOnClick = true,
			checked          = true,
			func = function(self, arg1)
				WCCreator_Lib.structures.CurrentFilters[1]             = not WCCreator_Lib.structures.CurrentFilters[1];
				WCCreator_Lib.structures.WCCFilterMenu.info[1].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[1].checked;
				WC_Lib.DisplayGuidesByFilter("WCC");
			end
		},
		{   text = core.L["MountNotCollected"],
			arg1 = core.L["MountNotCollected"],
			isNotRadio       = true,
			disabled         = false,
			keepShownOnClick = true,
			checked          = true,
			func = function(self, arg1)
				WCCreator_Lib.structures.CurrentFilters[2]             = not WCCreator_Lib.structures.CurrentFilters[2];
				WCCreator_Lib.structures.WCCFilterMenu.info[2].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[2].checked;
				WC_Lib.DisplayGuidesByFilter("WCC");
			end
		},
		{   text = core.L["Catégorie"],
			hasArrow     = true,
			notCheckable = true,
			menuList = {
				{	text = core.L["Hauts-faits"],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[3]                         = not WCCreator_Lib.structures.CurrentFilters[3];
						WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[1].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[1].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["Mounts"],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[4]                         = not WCCreator_Lib.structures.CurrentFilters[4];
						WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[2].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[2].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["Pets"],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[5]                         = not WCCreator_Lib.structures.CurrentFilters[5];
						WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[3].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[3].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{   text = core.L["Transmogs"],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[6]                         = not WCCreator_Lib.structures.CurrentFilters[6];
						WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[4].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[3].menuList[4].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
			},
			func = function(self, arg1)
			end
		},
		{   text = core.L["Difficulté"],
			hasArrow     = true,
			notCheckable = true,
			menuList = {
				{	text = core.L["Difficult"][1],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[7]                        = not WCCreator_Lib.structures.CurrentFilters[7];
						WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[1].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[1].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["Difficult"][2],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[8]                        = not WCCreator_Lib.structures.CurrentFilters[8];
						WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[2].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[2].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["Difficult"][3],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[9]                        = not WCCreator_Lib.structures.CurrentFilters[9];
						WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[3].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[4].menuList[3].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
			},
			func = function(self, arg1)
			end
		},
		{   text = core.L["Faction"],
			hasArrow     = true,
			notCheckable = true,
			menuList = {
				{	text = core.L["FactionList"][1],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[10]                        = not WCCreator_Lib.structures.CurrentFilters[10];
						WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[1].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[1].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["FactionList"][2],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[11]                        = not WCCreator_Lib.structures.CurrentFilters[11];
						WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[2].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[2].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["FactionList"][3],
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[12]                        = not WCCreator_Lib.structures.CurrentFilters[12];
						WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[3].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[5].menuList[3].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
			},
			func = function(self, arg1)
			end
		},
		{   text = core.L["Expansion"],
			hasArrow     = true,
			notCheckable = true,
			menuList = {
				{	text = core.L["Tout cocher"],
					disabled         = false,
					keepShownOnClick = true,
					notCheckable     = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[13]                         = true;
						WCCreator_Lib.structures.CurrentFilters[14]                         = true;
						WCCreator_Lib.structures.CurrentFilters[15]                         = true;
						WCCreator_Lib.structures.CurrentFilters[16]                         = true;
						WCCreator_Lib.structures.CurrentFilters[17]                         = true;
						WCCreator_Lib.structures.CurrentFilters[18]                         = true;
						WCCreator_Lib.structures.CurrentFilters[19]                         = true;
						WCCreator_Lib.structures.CurrentFilters[20]                         = true;
						WCCreator_Lib.structures.CurrentFilters[21]                         = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[3].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[4].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[5].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[6].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[7].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[8].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[9].checked  = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[10].checked = true;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[11].checked = true;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = core.L["Tout décocher"],
					disabled         = false,
					keepShownOnClick = true,
					notCheckable     = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[13]                         = false;
						WCCreator_Lib.structures.CurrentFilters[14]                         = false;
						WCCreator_Lib.structures.CurrentFilters[15]                         = false;
						WCCreator_Lib.structures.CurrentFilters[16]                         = false;
						WCCreator_Lib.structures.CurrentFilters[17]                         = false;
						WCCreator_Lib.structures.CurrentFilters[18]                         = false;
						WCCreator_Lib.structures.CurrentFilters[19]                         = false;
						WCCreator_Lib.structures.CurrentFilters[20]                         = false;
						WCCreator_Lib.structures.CurrentFilters[21]                         = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[3].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[4].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[5].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[6].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[7].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[8].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[9].checked  = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[10].checked = false;
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[11].checked = false;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Classic",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[13]                        = not WCCreator_Lib.structures.CurrentFilters[13];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[3].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[3].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Burning Crusade",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[14]                        = not WCCreator_Lib.structures.CurrentFilters[14];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[4].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[4].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Wrath of the Lich King",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[15]                        = not WCCreator_Lib.structures.CurrentFilters[15];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[5].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[5].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Cataclysm",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[16]                        = not WCCreator_Lib.structures.CurrentFilters[16];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[6].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[6].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Mist of Pandaria",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[17]                        = not WCCreator_Lib.structures.CurrentFilters[17];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[7].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[7].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Warlords of Draenor",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[18]                        = not WCCreator_Lib.structures.CurrentFilters[18];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[8].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[8].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Legion",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[19]                        = not WCCreator_Lib.structures.CurrentFilters[19];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[9].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[9].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Battle for Azeroth",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[20]                         = not WCCreator_Lib.structures.CurrentFilters[20];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[10].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[10].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
				{	text = "Shadowlands",
					isNotRadio       = true,
					disabled         = false,
					keepShownOnClick = true,
					checked          = true,
					func = function(self)
						WCCreator_Lib.structures.CurrentFilters[21]                         = not WCCreator_Lib.structures.CurrentFilters[21];
						WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[11].checked = not WCCreator_Lib.structures.WCCFilterMenu.info[6].menuList[11].checked;
						WC_Lib.DisplayGuidesByFilter("WCC");
					end
				},
			},
			func = function(self, arg1)
			end
		},
	}
};

WCCreator_Lib.structures.PageMenu = {
	frameOwner = nil;
	info = {
		{	text = core.L["Changer d'icône"],
			arg1 = core.L["Changer d'icône"],
			notCheckable = true,
			disabled = false,
			func = function(self)
				WCCreator_Lib.ToggleShowListIconSelector(WCCreator_Lib.structures.PageMenu.frameOwner);
				PlaySound("83", "sfx");
			end
		},
		{	text = core.L["Ajouter une nouvelle page"],
			arg1 = core.L["Ajouter une nouvelle page"],
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				local guide = WC_Lib.GetGuideByID(WCCreator_Lib.structures.PageMenu.frameOwner.idGuide, WCCreator_Lib.structures.PageMenu.frameOwner.addon);
				local addingPage = {id = WCCreator_Lib.structures.PageMenu.frameOwner.id + 1, icon = "Interface\\ICONS\\inv_misc_questionmark", rens = {{category = "NPC", displayID = "", stepAssigned = "", title = core.L["Informations Cadre"], onMap = { enable = false, pins = {}}}}, step = { { help = "", important = false, task = { {taskType = "custom", title = core.L["Titre quête"], tooltipText = core.L["Description quête"]}} }}};
				table.insert(guide.page, WCCreator_Lib.structures.PageMenu.frameOwner.id + 1, addingPage);
				WC_Lib.RefreshAllBtnPageCollection(guide, "WCC");
				WCCreator_Lib.UpdateVersionGuide(guide);
				PlaySound("83", "sfx");
			end
		},
		{	text = core.L["Dupliquer la page"],
			arg1 = core.L["Dupliquer la page"],
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				local guide = WC_Lib.GetGuideByID(WCCreator_Lib.structures.PageMenu.frameOwner.idGuide, WCCreator_Lib.structures.PageMenu.frameOwner.addon);
				local duplicatePage = WCCreator_Lib.deepCopy(guide.page[WCCreator_Lib.structures.PageMenu.frameOwner.id]);
				table.insert(guide.page, WCCreator_Lib.structures.PageMenu.frameOwner.id + 1, duplicatePage);
				WC_Lib.RefreshAllBtnPageCollection(guide, "WCC");
				WCCreator_Lib.UpdateVersionGuide(guide);
				PlaySound("83", "sfx");
			end
		},
		{   text = core.L["Supprimer cette page"],
			arg1 = core.L["Supprimer cette page"],
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				local guide = WC_Lib.GetGuideByID(WCCreator_Lib.structures.PageMenu.frameOwner.idGuide, "WCC");
				for i = 1, #guide.page[WCCreator_Lib.structures.PageMenu.frameOwner.id].step do
					table.remove(guide.page[WCCreator_Lib.structures.PageMenu.frameOwner.id].step, i);
				end
				table.remove(guide.page, WCCreator_Lib.structures.PageMenu.frameOwner.id);
				WC_Lib.RefreshAllBtnPageCollection(guide, "WCC");
				if (g_pageSelected["WCC"] == WCCreator_Lib.structures.PageMenu.frameOwner.id) then
					g_pageSelected["WCC"] = "";
					_G["WCC_PageBtn1"]:Click();
				end
				WCCreator_Lib.UpdateVersionGuide(guide);
				PlaySound("882", "sfx");				
			end
		},
	}
};

WCCreator_Lib.structures.WCCGuideMenu = {
	frameOwner = nil;
	info = {
		{	text = core.L["Exporter"],
			arg1 = core.L["Exporter"],
			notCheckable = true,
			disabled = false,
			func = function(self)
				WC_Lib.ShowPopupExport(WCCreator_Lib.structures.WCCGuideMenu.frameOwner.idGuide, WCCreator_Lib.structures.WCCGuideMenu.frameOwner.addon);
				PlaySound("83", "sfx");
			end
		},
		{	text = core.L["Dupliquer"],
			arg1 = core.L["Dupliquer"],
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				local confirmDialog = StaticPopup_Show("WC_ConfirmDialog", core.L["Voulez-vous dupliquer"].." |cFFF5CC00"..WCCreator_Lib.structures.WCCGuideMenu.frameOwner.nameGuide.."|r ?");
				confirmDialog.func  = function()
					WCCreator_Lib.DuplicateCollection(WCCreator_Lib.structures.WCCGuideMenu.frameOwner.idGuide);
					PlaySound("39673", "sfx");
				end;
			end
		},
		{   text = core.L["Supprimer"],
			arg1 = core.L["Supprimer"],
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				local confirmDialog = StaticPopup_Show("WC_ConfirmDialog", core.L["Voulez-vous supprimer"].." |cFFF5CC00"..WCCreator_Lib.structures.WCCGuideMenu.frameOwner.nameGuide.."|r ?\nID: |cff00c8ff"..WCCreator_Lib.structures.WCCGuideMenu.frameOwner.idGuide.."|r");
				confirmDialog.func  = function() WC_Lib.DeleteCollection(WCCreator_Lib.structures.WCCGuideMenu.frameOwner.idGuide, WCCreator_Lib.structures.WCCGuideMenu.frameOwner.addon); end;
			end
		},
	}
};

WCCreator_Lib.structures.MS_Category = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["Hauts-faits"],
	frameTitle = "MS_Category",
	info = {
		{	text = core.L["Catégorie"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Hauts-faits"],
			arg1 = core.L["Hauts-faits"],
			arg2 = "hf",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.category = arg2;
					WCCreator_Lib.structures.MainSettings_value.id = "";
					WCCreator_Lib.structures.MainSettings_value.displayID = 0;
					WCCreator_Lib.structures.MainSettings_value.modID = 0;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
					_G["WCC_textbox_MS_IdAchiev"]:SetText("");
					_G["WCC_textbox_MS_IdAchiev"]:Show();
					_G["WCC_textbox_MS_IdAchievBtn"]:Show();
					_G["WCC_textbox_MS_IdMounts"]:Hide();
					_G["WCC_textbox_MS_IdMountsBtn"]:Hide();
					_G["WCC_textbox_MS_IdPets"]:Hide();
					_G["WCC_textbox_MS_IdPetsBtn"]:Hide();
					_G["WCC_textbox_MS_IdTransmogs"]:Hide();
					_G["WCC_textbox_MS_IdTransmogsBtn"]:Hide();
					_G["WCC_textbox_MS_ModID"]:Hide();
					WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_MS_DisplayID"]);
					_G["WCC_textbox_MS_DisplayIDBtn"]:Disable();
					_G["WCC_textbox_MS_DisplayID"]:Show();
					_G["WCC_MS_PreviewCategory"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallengerCREATOR/images/hf_category"});
					_G["WCC_MS_PreviewCategory"].cat = arg1;
				end
			end
		},
		{	text = core.L["Mounts"],
			arg1 = core.L["Mounts"]
			,
			arg2 = "mounts",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.category = arg2;
					WCCreator_Lib.structures.MainSettings_value.id = "";
					WCCreator_Lib.structures.MainSettings_value.displayID = 0;
					WCCreator_Lib.structures.MainSettings_value.modID = 0;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
					_G["WCC_textbox_MS_IdMounts"]:SetText("");
					_G["WCC_textbox_MS_IdMounts"]:Show();
					_G["WCC_textbox_MS_IdMountsBtn"]:Show();
					_G["WCC_textbox_MS_IdAchiev"]:Hide();
					_G["WCC_textbox_MS_IdAchievBtn"]:Hide();
					_G["WCC_textbox_MS_IdPets"]:Hide();
					_G["WCC_textbox_MS_IdPetsBtn"]:Hide();
					_G["WCC_textbox_MS_IdTransmogs"]:Hide();
					_G["WCC_textbox_MS_IdTransmogsBtn"]:Hide();
					_G["WCC_textbox_MS_ModID"]:Hide();
					_G["WCC_textbox_MS_DisplayID"]:SetText("");
					_G["WCC_textbox_MS_DisplayID"]:Show();
					_G["WCC_textbox_MS_DisplayIDBtn"]:Enable();
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_MS_DisplayID"]);
					_G["WCC_MS_PreviewCategory"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallengerCREATOR/images/mount_category"});
					_G["WCC_MS_PreviewCategory"].cat = arg1;
				end
			end
		},
		{   text = core.L["Pets"],
			arg1 = core.L["Pets"],
			arg2 = "pets",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.category = arg2;
					WCCreator_Lib.structures.MainSettings_value.id = "";
					WCCreator_Lib.structures.MainSettings_value.displayID = 0;
					WCCreator_Lib.structures.MainSettings_value.modID = 0;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
					_G["WCC_textbox_MS_IdPets"]:SetText("");
					_G["WCC_textbox_MS_IdPets"]:Show();
					_G["WCC_textbox_MS_IdPetsBtn"]:Show();
					_G["WCC_textbox_MS_IdAchiev"]:Hide();
					_G["WCC_textbox_MS_IdAchievBtn"]:Hide();
					_G["WCC_textbox_MS_IdMounts"]:Hide();
					_G["WCC_textbox_MS_IdMountsBtn"]:Hide();
					_G["WCC_textbox_MS_IdTransmogs"]:Hide();
					_G["WCC_textbox_MS_IdTransmogsBtn"]:Hide();
					_G["WCC_textbox_MS_ModID"]:Hide();
					_G["WCC_textbox_MS_DisplayID"]:SetText("");
					_G["WCC_textbox_MS_DisplayID"]:Show();
					_G["WCC_textbox_MS_DisplayIDBtn"]:Enable();
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_MS_DisplayID"]);
					_G["WCC_MS_PreviewCategory"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallengerCREATOR/images/pet_category"});
					_G["WCC_MS_PreviewCategory"].cat = arg1;
				end
			end
		},
		{ 	text = core.L["Transmogs"],
			arg1 = core.L["Transmogs"],
			arg2 = "transmogs",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.category = arg2;
					WCCreator_Lib.structures.MainSettings_value.id = "";
					WCCreator_Lib.structures.MainSettings_value.displayID = 0;
					WCCreator_Lib.structures.MainSettings_value.modID = 0;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
					_G["WCC_textbox_MS_IdAchiev"]:Hide();
					_G["WCC_textbox_MS_IdAchievBtn"]:Hide();
					_G["WCC_textbox_MS_IdMounts"]:Hide();
					_G["WCC_textbox_MS_IdMountsBtn"]:Hide();
					_G["WCC_textbox_MS_IdPets"]:Hide();
					_G["WCC_textbox_MS_IdPetsBtn"]:Hide();
					_G["WCC_textbox_MS_IdTransmogs"]:SetText("");
					_G["WCC_textbox_MS_IdTransmogs"]:Show();
					_G["WCC_textbox_MS_IdTransmogsBtn"]:Show();
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_MS_DisplayID"]);
					_G["WCC_textbox_MS_DisplayID"]:Hide();
					_G["WCC_textbox_MS_ModID"]:SetText("");
					_G["WCC_textbox_MS_ModID"]:Show();
					_G["WCC_textbox_MS_DisplayIDBtn"]:Enable();
					_G["WCC_MS_PreviewCategory"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallengerCREATOR/images/transmog_category"});
					_G["WCC_MS_PreviewCategory"].cat = arg1;
				end
			end
		},
	}
};

WCCreator_Lib.structures.MS_Faction = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r "..core.L["Neutre"],
	frameTitle = "MS_Faction",
	info = {
		{	text = core.L["Faction"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Neutre"],
			arg1 = core.L["Neutre"],
			arg2 = 3,
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.faction) then
					WCCreator_Lib.structures.MainSettings_value.faction = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r " ..core.L["FactionList"][arg2]);
					CloseDropDownMenus();
					_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = ""});
				end
			end
		},
		{	text = core.L["Alliance"],
			arg1 = core.L["Alliance"],
			arg2 = 1,
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.faction) then
					WCCreator_Lib.structures.MainSettings_value.faction = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r " ..core.L["FactionList"][arg2]);
					CloseDropDownMenus();
					_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallenger/images/mounts/button_bg_alliance"});
				end
			end
		},
		{	text = core.L["Horde"],
			arg1 = core.L["Horde"],
			arg2 = 2;
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.faction) then
					WCCreator_Lib.structures.MainSettings_value.faction = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Faction"], "|cFFF5CC00"..core.L["Faction"]..core.L["2points"].."|r " ..core.L["FactionList"][arg2]);
					CloseDropDownMenus();
					_G["WCC_MS_PreviewFaction"]:SetBackdrop({bgFile = "Interface/AddOns/WoWChallenger/images/mounts/button_bg_horde"});
				end
			end
		},
	}
};

WCCreator_Lib.structures.MS_Expansion = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r "..core.L["Non précisé"],
	frameTitle = "MS_Expansion",
	info = {
		{	text = core.L["Expansion"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = "Shadowlands",
			arg1 = "Shadowlands",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r" ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Battle for Azeroth",
			arg1 = "Battle for Azeroth",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Legion",
			arg1 = "Legion",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Warlords of Draenor",
			arg1 = "Warlords of Draenor",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Mist of Pandaria",
			arg1 = "Mist of Pandaria",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Cataclysm",
			arg1 = "Cataclysm",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Wrath of the Lich King",
			arg1 = "Wrath of the Lich King",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Burning Crusade",
			arg1 = "Burning Crusade",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = "Classic",
			arg1 = "Classic",
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.MainSettings_value.category) then
					WCCreator_Lib.structures.MainSettings_value.expansion = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Expansion"], "|cFFF5CC00"..core.L["Expansion"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.MS_Difficulty = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Difficulté"]..core.L["2points"].."|r "..core.L["Difficult"][1],
	frameTitle = "MS_Difficulty",
	info = {
		{	text = core.L["Difficulté"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Difficult"][1],
			arg1 = core.L["Difficult"][1],
			arg2 = 1,
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.difficulty) then
					WCCreator_Lib.structures.MainSettings_value.difficulty = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Difficulty"], "|cFFF5CC00"..core.L["Difficulté"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Difficult"][2],
			arg1 = core.L["Difficult"][2],
			arg2 = 2,
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.difficulty) then
					WCCreator_Lib.structures.MainSettings_value.difficulty = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Difficulty"], "|cFFF5CC00"..core.L["Difficulté"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Difficult"][3],
			arg1 = core.L["Difficult"][3],
			arg2 = 3,
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.difficulty) then
					WCCreator_Lib.structures.MainSettings_value.difficulty = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Difficulty"], "|cFFF5CC00"..core.L["Difficulté"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.MS_Langage = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r English",
	frameTitle = "MS_Langage",
	info = {
		{	text = core.L["Langue"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["LangSTR"][1],
			arg1 = core.L["LangSTR"][1],
			arg2 = {1, 2},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][3],
			arg1 = core.L["LangSTR"][3],
			arg2 = {3},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][4],
			arg1 = core.L["LangSTR"][4],
			arg2 = {4},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][5],
			arg1 = core.L["LangSTR"][5],
			arg2 = {5},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][6],
			arg1 = core.L["LangSTR"][6],
			arg2 = {6},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][7],
			arg1 = core.L["LangSTR"][7],
			arg2 = {7},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][8],
			arg1 = core.L["LangSTR"][8],
			arg2 = {8},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][9],
			arg1 = core.L["LangSTR"][9],
			arg2 = {9},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][10],
			arg1 = core.L["LangSTR"][10],
			arg2 = {10},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][11],
			arg1 = core.L["LangSTR"][11],
			arg2 = {11},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["LangSTR"][12],
			arg1 = core.L["LangSTR"][12],
			arg2 = {12},
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.MainSettings_value.lang) then
					WCCreator_Lib.structures.MainSettings_value.lang = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_MS_Langage"], "|cFFF5CC00"..core.L["Langue"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.MS_ClassAll = {
	frameType = "checkbox",
	title = core.L["Toutes"],
	size = 30,
	frameTitle = "MS_ClassAll",
	checked = true,
	disabled = false,
	func = function()
		if (_G["WCC_checkbox_MS_ClassAll"]:GetChecked() == true) then
			for i = 1, 12 do
				_G["WCC_checkbox_MS_Class"..i]:SetChecked(true);
				_G["WCC_checkbox_MS_Class"..i]:Disable();
				WCCreator_Lib.structures.MainSettings_value.class[i] = true;
			end
		else
			for i = 1, 12 do
				_G["WCC_checkbox_MS_Class"..i]:Enable();
				_G["WCC_checkbox_MS_Class"..i]:SetChecked(false);
				WCCreator_Lib.structures.MainSettings_value.class[i] = false;
			end
		end
	end
};

function changeValueClassMS(classID)
	if (_G["WCC_checkbox_MS_Class"..classID]:GetChecked() == true) then
		WCCreator_Lib.structures.MainSettings_value.class[classID] = true;
	else
		WCCreator_Lib.structures.MainSettings_value.class[classID] = false;
	end
end

WCCreator_Lib.structures.MS_Class1 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][1],
	size = 30,
	frameTitle = "MS_Class1",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(1) end
};
WCCreator_Lib.structures.MS_Class2 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][2],
	size = 30,
	frameTitle = "MS_Class2",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(2) end
};
WCCreator_Lib.structures.MS_Class3 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][3],
	size = 30,
	frameTitle = "MS_Class3",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(3) end
};
WCCreator_Lib.structures.MS_Class4 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][4],
	size = 30,
	frameTitle = "MS_Class4",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(4) end
};
WCCreator_Lib.structures.MS_Class5 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][5],
	size = 30,
	frameTitle = "MS_Class5",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(5) end
};
WCCreator_Lib.structures.MS_Class6 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][6],
	size = 30,
	frameTitle = "MS_Class6",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(6) end
};
WCCreator_Lib.structures.MS_Class7 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][7],
	size = 30,
	frameTitle = "MS_Class7",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(7) end
	
};
WCCreator_Lib.structures.MS_Class8 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][8],
	size = 30,
	frameTitle = "MS_Class8",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(8) end
};
WCCreator_Lib.structures.MS_Class9 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][9],
	size = 30,
	frameTitle = "MS_Class9",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(9) end
};
WCCreator_Lib.structures.MS_Class10 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][10],
	size = 30,
	frameTitle = "MS_Class10",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(10) end
};
WCCreator_Lib.structures.MS_Class11 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][11],
	size = 30,
	frameTitle = "MS_Class11",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(11) end
};
WCCreator_Lib.structures.MS_Class12 = {
	frameType = "checkbox",
	title = core.L["ClassesList"][12],
	size = 30,
	frameTitle = "MS_Class12",
	checked = true,
	disabled = true,
	func = function() changeValueClassMS(12) end
};



-- ===== SETTINGS RENSEIGNEMENTS ===== --
WCCreator_Lib.structures.SettingsRens_value = {
	info = {
		arrRens    = nil;
		idRens     = nil;
		idPage     = nil;
		idGuide    = nil;
		bIsNew     = nil;
	},
	category     = "NPC",
	displayID    = "",
	title        = "",
	stepAssigned = "",
	onMap        = {
		enable = false,
		pins = {},
	}
};

WCCreator_Lib.structures.SR_Category = {
	frameType = "dropdownmenu",
	width = 125,
	title = "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["PNJ"],
	frameTitle = "SR_Category",
	info = {
		{	text = core.L["Catégorie"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["PNJ"],
			arg1 = core.L["PNJ"],
			arg2 = "NPC",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsRens_value.category) then
					WCCreator_Lib.structures.SettingsRens_value.category = arg2;
					_G["WCC_textbox_SR_DisplayID"]:Show();
					_G["WCC_textbox_SR_FileID"]:Hide();
					_G["WCC_textbox_SR_DisplayID"]:SetText("");
					_G["WCC_textbox_SR_FileID"]:SetText("");
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_checkbox_SR_OnMap"]:Enable();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Environnement"],
			arg1 = core.L["Environnement"],
			arg2 = "ENV",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsRens_value.category) then
					WCCreator_Lib.structures.SettingsRens_value.category = arg2;
					_G["WCC_textbox_SR_DisplayID"]:Hide();
					_G["WCC_textbox_SR_FileID"]:Show();
					_G["WCC_textbox_SR_DisplayID"]:SetText("");
					_G["WCC_textbox_SR_FileID"]:SetText("");
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_checkbox_SR_OnMap"]:Enable();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Zone"],
			arg1 = core.L["Zone"],
			arg2 = "ZONE",
			func = function(self, arg1, arg2)
				if (arg1 ~= WCCreator_Lib.structures.SettingsRens_value.category) then
					WCCreator_Lib.structures.SettingsRens_value.category = arg2;
					_G["WCC_textbox_SR_DisplayID"]:SetText("");
					_G["WCC_textbox_SR_DisplayID"]:Hide();
					_G["WCC_textbox_SR_FileID"]:Hide();
					_G["WCC_checkbox_SR_OnMap"]:SetChecked(true);
					_G["WCC_checkbox_SR_OnMap"]:Disable();
					WCCreator_Lib.structures.SettingsRens_value.onMap.enable = _G["WCC_checkbox_SR_OnMap"]:GetChecked();
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionX"]);
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionY"]);
					WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_IDZone"]);
					_G["WCC_checkbox_SR_IsEntry"]:Enable();
					_G["WCC_checkbox_SR_FilPins_Btn"]:Enable();
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_SR_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.SR_DisplayID = {
	frameType = "textbox",
	width = 125,
	title = core.L["DisplayID"],
	frameTitle = "SR_DisplayID",
	desc = core.L["ID du model 3D du PNJ. Survolez un PNJ avec votre souris pour voir son DisplayID"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsRens_value.displayID = _G["WCC_textbox_SR_DisplayID"]:GetText();
			end	
		},
	},
	button = {
		title = core.L["Aperçu"],
		desc = core.L["Aperçu visuel du model 3D"],
		width = 70,
		func = function (self)
			WCCreator_Lib.ShowPopupModelView("NPC", WCCreator_Lib.structures.SettingsRens_value.displayID);
		end
	},
};

WCCreator_Lib.structures.SR_FileID = {
	frameType = "textbox",
	width = 125,
	title = core.L["FileID"],
	frameTitle = "SR_FileID",
	desc = core.L["Le site WoW.tools peut vous être utile"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsRens_value.displayID = _G["WCC_textbox_SR_FileID"]:GetText();
			end	
		},
	},
	button = {
		title = core.L["Aperçu"],
		desc = core.L["Aperçu visuel du model 3D"],
		width = 70,
		func = function (self)
			WCCreator_Lib.ShowPopupModelView("ENV", WCCreator_Lib.structures.SettingsRens_value.displayID);
		end
	},
};

WCCreator_Lib.structures.SR_Title = {
	frameType = "textbox",
	width = 250,
	title = core.L["Titre"],
	frameTitle = "SR_Title",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsRens_value.title = _G["WCC_textbox_SR_Title"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.SR_StepAssigned = {
	frameType = "textbox",
	width = 50,
	title = core.L["Etape"],
	frameTitle = "SR_StepAssigned",
	desc = core.L["Les informations de ce cadre correspondront à l'étape que vous indiquerez"],
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsRens_value.stepAssigned = _G["WCC_textbox_SR_StepAssigned"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.SR_OnMap = {
	frameType = "checkbox",
	title = core.L["Afficher sur la carte"],
	size = 30,
	frameTitle = "SR_OnMap",
	checked = false,
	disabled = false,
	func = function()
		local isChecked =  _G["WCC_checkbox_SR_OnMap"]:GetChecked();
		WCCreator_Lib.structures.SettingsRens_value.onMap.enable = isChecked;
		_G["WCC_checkbox_SR_FilPins_Btn"]:SetEnabled(isChecked);
		if (isChecked == true) then
			WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionX"]);
			WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_PositionY"]);
			WCCreator_Lib.TextBoxSetEnable(_G["WCC_textbox_SR_IDZone"]);
			_G["WCC_checkbox_SR_IsEntry"]:Enable();
		else
			WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_PositionX"]);
			WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_PositionY"]);
			WCCreator_Lib.TextBoxSetDisable(_G["WCC_textbox_SR_IDZone"]);
			_G["WCC_checkbox_SR_IsEntry"]:Disable();
			_G["WCC_textbox_SR_PositionX"]:SetText("");
			_G["WCC_textbox_SR_PositionY"]:SetText("");
			_G["WCC_textbox_SR_IDZone"]:SetText("");
			_G["WCC_checkbox_SR_IsEntry"]:SetChecked(false);
		end
	end
};

WCCreator_Lib.structures.SR_PositionX = {
	frameType = "textbox",
	width = 50,
	title = core.L["Valeur X"],
	frameTitle = "SR_PositionX",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local posX   = _G["WCC_textbox_SR_PositionX"]:GetText();
				local posY   = _G["WCC_textbox_SR_PositionY"]:GetText();
				local IDZone = _G["WCC_textbox_SR_IDZone"]:GetText();
				if (WCCreator_Lib.checkIfLetter(posX, true, true) == true or WCCreator_Lib.checkIfMultipleLetter(posX, '.', 2) == true) then
					_G["WCC_textbox_SR_PositionX"]:SetText(posX:sub(1, #posX - 1));
				end
				if (posX ~= "" and posY ~= "" and IDZone ~= "") then
					_G["WCC_SR_AddPins_Btn"]:Enable();
				else
					_G["WCC_SR_AddPins_Btn"]:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.SR_PositionY = {
	frameType = "textbox",
	width = 50,
	title = core.L["Valeur Y"],
	frameTitle = "SR_PositionY",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local posX   = _G["WCC_textbox_SR_PositionX"]:GetText();
				local posY   = _G["WCC_textbox_SR_PositionY"]:GetText();
				local IDZone = _G["WCC_textbox_SR_IDZone"]:GetText();
				if (WCCreator_Lib.checkIfLetter(posY, true, true) == true or WCCreator_Lib.checkIfMultipleLetter(posX, '.', 2) == true) then
					_G["WCC_textbox_SR_PositionY"]:SetText(posY:sub(1, #posY - 1));
				end
				if (posX ~= "" and posY ~= "" and IDZone ~= "") then
					_G["WCC_SR_AddPins_Btn"]:Enable();
				else
					_G["WCC_SR_AddPins_Btn"]:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.SR_IDZone = {
	frameType = "textbox",
	width = 50,
	title = core.L["ID Zone"],
	frameTitle = "SR_IDZone",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local posX   = _G["WCC_textbox_SR_PositionX"]:GetText();
				local posY   = _G["WCC_textbox_SR_PositionY"]:GetText();
				local IDZone = _G["WCC_textbox_SR_IDZone"]:GetText();
				WCCreator_Lib.structures.SettingsRens_value.IDZone = _G["WCC_textbox_SR_IDZone"]:GetText();
				if (posX ~= "" and posY ~= "" and IDZone ~= "") then
					_G["WCC_SR_AddPins_Btn"]:Enable();
				else
					_G["WCC_SR_AddPins_Btn"]:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.SR_IsEntry = {
	frameType = "checkbox",
	title = core.L["Est une entrée"],
	size = 30,
	frameTitle = "SR_IsEntry",
	checked = false,
};

-- ===== SETTINGS STEP ===== --
WCCreator_Lib.structures.SettingsStep_value = {
	info = {
		arrSteps = nil;
		idStep   = nil;
		idPage   = nil;
		idGuide  = nil;
	},
	help         = "",
	important    = false,
	task         = {},
};


WCCreator_Lib.structures.SS_Help = {
	frameType = "multiline",
	width = 255,
	height = 80,
	title = core.L["Aide"],
	frameTitle = "SS_Help",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsStep_value.help = _G["WCC_multiline_SS_Help"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.SS_Important = {
	frameType = "checkbox",
	title = core.L["Important"],
	size = 30,
	frameTitle = "SS_Important",
	checked = false,
	disabled = false,
	func = function()
		WCCreator_Lib.structures.SettingsStep_value.important = _G["WCC_checkbox_SS_Important"]:GetChecked();		
	end
};

-- ===== SETTINGS TASK ===== --
WCCreator_Lib.structures.SettingsTask_value = {
	info = {
		arrTasks      = nil;
		allIdFromTask = nil;
	},
	category = nil,
	--- Custom Part ---
	title = "",
	desc  = "",
	--- HF Part ---
	idHF = "",
	--- Quest Part ---
	idQuest      = "",
	bForceQuest  = false,
	bAutoRefresh = false,
	--- Item Part ---	
	idItem                = "",
	itemInfo              = {};
	nbRequired            = 1,
	obtentionType         = "none",
	obtention_loot        = {},
	obtention_vendor      = {},
	obtention_create      = {},
	obtention_profession  = "none",
	obtention_IdQuest     = "",
	obtention_IdHF        = "",
	obtention_titleQuest  = "",
	obtention_titleHF     = "",
	validationType        = "manual",
	validationId          = "",
	validationModId       = "",
	--validationHiddenQuest = false,
};


WCCreator_Lib.structures.ST_Category = {
	frameType = "dropdownmenu",
	width = 250,
	title = "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r "..core.L["Custom"],
	frameTitle = "ST_Category",
	info = {
		{	text = core.L["Catégorie"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Custom"],
			arg1 = core.L["Custom"],
			arg2 = "custom",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.category) then
					WCCreator_Lib.structures.SettingsTask_value.category = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].AchievFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].QuestFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].CustomFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Haut-fait"],
			arg1 = core.L["Haut-fait"],
			arg2 = "hf",
			func = function(self, arg1, arg2)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.category) then
					WCCreator_Lib.structures.SettingsTask_value.category = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].CustomFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].QuestFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].AchievFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Quest"],
			arg1 = core.L["Quest"],
			arg2 = "quest",
			func = function(self, arg1, arg2)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.category) then
					WCCreator_Lib.structures.SettingsTask_value.category = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].AchievFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].CustomFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].QuestFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Hide();
					WCCreator_Lib.ShowForceQuest();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Item"],
			arg1 = core.L["Item"],
			arg2 = "need",
			func = function(self, arg1, arg2)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.category) then
					WCCreator_Lib.structures.SettingsTask_value.category = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Category"], "|cFFF5CC00"..core.L["Catégorie"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].AchievFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].CustomFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].QuestFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame:Show();
					if (WCCreator_Lib.structures.SettingsTask_value.obtentionType ~= "none") then
						_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					else
						_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Hide();
					end
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.ST_Title = {
	frameType = "textbox",
	width = 280,
	title = core.L["Titre"],
	frameTitle = "ST_Title",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.title = _G["WCC_textbox_ST_Title"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Desc = {
	frameType = "multiline",
	width = 265,
	height = 80,
	title = core.L["Description"],
	frameTitle = "ST_Desc",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.desc = _G["WCC_multiline_ST_Desc"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_IdAchiev = {
	frameType = "textbox",
	width = 280,
	title = core.L["ID Haut-fait"],
	frameTitle = "ST_IdAchiev",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.idHF = _G["WCC_textbox_ST_IdAchiev"]:GetText();
			end	
		},
	},
};

WCCreator_Lib.structures.ST_IdQuest = {
	frameType = "textbox",
	width = 280,
	title = core.L["ID Quest"],
	frameTitle = "ST_IdQuest",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				if (_G["WCC_textbox_ST_IdQuest"]:HasFocus() == true) then
					WCCreator_Lib.structures.SettingsTask_value.idQuest      = _G["WCC_textbox_ST_IdQuest"]:GetText();
					WCCreator_Lib.structures.SettingsTask_value.bForceQuest  = false;
					WCCreator_Lib.structures.SettingsTask_value.bAutoRefresh = false;
					WCCreator_Lib.ShowForceQuest();
				end
			end	
		},
	},
};

WCCreator_Lib.structures.ST_TitleForce = {
	frameType = "textbox",
	width = 280,
	title = core.L["Titre"],
	frameTitle = "ST_TitleForce",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.title = _G["WCC_textbox_ST_TitleForce"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_DescForce = {
	frameType = "multiline",
	width = 255,
	height = 80,
	title = core.L["Description"],
	frameTitle = "ST_DescForce",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.desc = _G["WCC_multiline_ST_DescForce"]:GetText();
			end	
		},
	}
};


WCCreator_Lib.structures.ST_IdItem = {
	frameType = "textbox",
	width = 150,
	title = core.L["ID Objet"],
	frameTitle = "ST_IdItem",
	nbOnly = true,
	button = {
		title = core.L["Valider"],
		width = 70,
		func = function (self)
			local idItem = _G["WCC_textbox_ST_IdItem"]:GetText();
			if (idItem ~= "") then
				local item = Item:CreateFromItemID(tonumber(idItem));
				local isEmpty = item:IsItemEmpty();
				if (isEmpty == false) then
					item:ContinueOnItemLoad(function()
						local itemInfo = {GetItemInfo(tonumber(idItem))};
						WCCreator_Lib.structures.SettingsTask_value.idItem      = idItem;
						WCCreator_Lib.structures.SettingsTask_value.itemInfo[1] = itemInfo[1];
						WCCreator_Lib.structures.SettingsTask_value.itemInfo[2] = itemInfo[2];
						WCCreator_Lib.structures.SettingsTask_value.itemInfo[3] = itemInfo[3];
						WCCreator_Lib.structures.SettingsTask_value.itemInfo[4] = itemInfo[10];
						_G["WCC_textbox_ST_IdItemValid"]:SetText(idItem);
						_G["WCC_MenuSettingsTaskFrame"].ItemFrame.itemIcon:SetBackdrop({bgFile = itemInfo[10]});
						_G["WCC_MenuSettingsTaskFrame"].ItemFrame.itemIcon.itemLink = itemInfo[2];
						WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_IdItem", false);
						PlaySound("83", "sfx");
					end)
				else
					UIErrorsFrame:AddMessage(core.L["ErrorNoFindID"], 1, 0, 0);
					PlaySound("47355", "sfx", true);
				end
			end
		end
	},
};

WCCreator_Lib.structures.ST_IdItemValid = {
	frameType = "textbox",
	width = 150,
	title = core.L["ID Objet"],
	frameTitle = "ST_IdItemValid",
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_IdItem", true);
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.ST_NbRequired = {
	frameType = "textbox",
	width = 70,
	title = core.L["Nombre"],
	desc = core.L["Nombre d'exemplaire requis"],
	frameTitle = "ST_NbRequired",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.nbRequired = _G["WCC_textbox_ST_NbRequired"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Obtention = {
	frameType = "dropdownmenu",
	width = 210,
	title = "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r "..core.L["Non précisé"],
	frameTitle = "ST_Obtention",
	info = {
		{	text = core.L["Obtention"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["DroppedBy"],
			arg1 = core.L["DroppedBy"],
			arg2 = "loot",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.obtentionType) then
					WCCreator_Lib.structures.SettingsTask_value.obtentionType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention"], "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.subtitle3:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Obtention, "BOTTOM", 0, -90);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["DroppedBy"].."|r |cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:Hide();					
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHFValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshNPCDroppedLoot(WCCreator_Lib.structures.SettingsTask_value.obtention_loot));
					WCCreator_Lib.RefreshListOfItem(_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame.ListFrame, WCCreator_Lib.structures.SettingsTask_value.obtention_loot, _G["WCC_MenuSettingsTaskFrame"].arrLoot, {[1] = "nameNPC", [2] = "dropPercent"}, 1,
					function ()
						_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshNPCLoot(WCCreator_Lib.structures.SettingsTask_value.obtention_loot));
					end);
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["SoldBy"],
			arg1 = core.L["SoldBy"],
			arg2 = "vendor",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.obtentionType) then
					WCCreator_Lib.structures.SettingsTask_value.obtentionType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention"], "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.subtitle3:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Obtention, "BOTTOM", 0, -90);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["SoldBy"].."|r |cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:Hide();					
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHFValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshNPCVendor(WCCreator_Lib.structures.SettingsTask_value.obtention_vendor));
					WCCreator_Lib.RefreshListOfItem(_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame.ListFrame, WCCreator_Lib.structures.SettingsTask_value.obtention_vendor, _G["WCC_MenuSettingsTaskFrame"].arrVendor, nil, 1,
						function ()
							_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshNPCVendor(WCCreator_Lib.structures.SettingsTask_value.obtention_vendor));
						end);
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["CreatedBy"],
			arg1 = core.L["CreatedBy"],
			arg2 = "create",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.obtentionType) then
					WCCreator_Lib.structures.SettingsTask_value.obtentionType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention"], "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.subtitle3:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Obtention, "BOTTOM", 0, -90);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["CreatedBy"].."|r |cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHFValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					WCCreator_Lib.RefreshListOfItem(_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame.ListFrame, WCCreator_Lib.structures.SettingsTask_value.obtention_create, _G["WCC_MenuSettingsTaskFrame"].arrCreate, {[1] = "idItem", [2] = "nbNeed"}, 1,
						function ()
							_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
						end);
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["FinishQuest"],
			arg1 = core.L["FinishQuest"],
			arg2 = "quest",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.obtentionType) then
					WCCreator_Lib.structures.SettingsTask_value.obtentionType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention"], "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.subtitle3:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Obtention, "BOTTOM", 0, -90);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["FinishQuest"].."|r |cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHFValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["FinishHF"],
			arg1 = core.L["FinishHF"],
			arg2 = "hf",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.obtentionType) then
					WCCreator_Lib.structures.SettingsTask_value.obtentionType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention"], "|cFFF5CC00"..core.L["Obtention"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.subtitle3:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Obtention, "BOTTOM", 0, -90);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["FinishHF"].."|r |cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHFValid:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_IdQuest = {
	frameType = "textbox",
	width = 210,
	title = core.L["ID Quest"],
	frameTitle = "ST_Obtention_IdQuest",
	nbOnly = true,
	button = {
		title = core.L["Valider"],
		width = 70,
		func = function (self)
			local IdQuest = _G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuest:GetText();
			if (IdQuest ~= "" and tonumber(IdQuest) < 2147483647) then
				_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["FinishQuest"].."|r |cffffffff.|r");
				QuestEventListener:AddCallback(tonumber(IdQuest), function()
					local name = C_QuestLog.GetTitleForQuestID(tonumber(IdQuest));
					WCCreator_Lib.structures.SettingsTask_value.obtention_IdQuest    = IdQuest;
					WCCreator_Lib.structures.SettingsTask_value.obtention_titleQuest = name;
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["FinishQuest"].."|r"..name.."|cffffffff.|r");
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdQuestValid:SetText(IdQuest);
					_G["WCC_textbox_ST_Obtention_IdQuestBtn"]:Enable();
					WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_Obtention_IdQuest", false);
					PlaySound("83", "sfx");
				end)
			end
		end
	},
};

WCCreator_Lib.structures.ST_Obtention_IdQuestValid = {
	frameType = "textbox",
	width = 210,
	title = core.L["ID Quest"],
	frameTitle = "ST_Obtention_IdQuestValid",
	nbOnly = true,
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_Obtention_IdQuest", true);
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.ST_Obtention_IdHF = {
	frameType = "textbox",
	width = 210,
	title = core.L["ID Haut-fait"],
	frameTitle = "ST_Obtention_IdHF",
	nbOnly = true,
	button = {
		title = core.L["Valider"],
		width = 70,
		func = function (self)
			local IdHF = _G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_Obtention_IdHF:GetText();
			if (IdHF ~= "" and tonumber(IdHF) < 2147483647) then
				local _, name = GetAchievementInfo(tonumber(IdHF));
				WCCreator_Lib.structures.SettingsTask_value.obtention_IdHF    = IdHF;
				WCCreator_Lib.structures.SettingsTask_value.obtention_titleHF = name;
				_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText("|cffffffff"..core.L["FinishHF"].."|r"..name.."|cffffffff.|r");
				WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_Obtention_IdHF", false);			
				PlaySound("83", "sfx");
			end
		end
	},
};

WCCreator_Lib.structures.ST_Obtention_IdHFValid = {
	frameType = "textbox",
	width = 210,
	title = core.L["ID Haut-fait"],
	frameTitle = "ST_Obtention_IdHFValid",
	nbOnly = true,
	button = {
		title = core.L["Modifier"],
		width = 70,
		func = function (self)
			WCCreator_Lib.SwitchValidEdit("WCC_textbox_ST_Obtention_IdHF", true);
			PlaySound("83", "sfx");
		end
	},
};

WCCreator_Lib.structures.ST_Obtention_lootNameNPC = {
	frameType = "textbox",
	width = 140,
	title = core.L["Nom PNJ"],
	frameTitle = "ST_Obtention_lootNameNPC",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local dropText = _G["WCC_textbox_ST_Obtention_dropPercent"]:GetText(); 
				if (_G["WCC_textbox_ST_Obtention_lootNameNPC"]:GetText() ~= "" and dropText ~= "" and dropText ~= ".") then
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame.AddBtn:Enable();
				else
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame.AddBtn:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_dropPercent = {
	frameType = "textbox",
	width = 60,
	title = core.L["Pourcentage"],
	frameTitle = "ST_Obtention_dropPercent",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				local dropText = _G["WCC_textbox_ST_Obtention_dropPercent"]:GetText();
				if (WCCreator_Lib.checkIfLetter(dropText, true) == true or WCCreator_Lib.checkIfMultipleLetter(dropText, '.', 2) == true) then
					_G["WCC_textbox_ST_Obtention_dropPercent"]:SetText(dropText:sub(1, #dropText - 1));
				end
				local newDropText = _G["WCC_textbox_ST_Obtention_dropPercent"]:GetText();
				if (_G["WCC_textbox_ST_Obtention_lootNameNPC"]:GetText() ~= "" and newDropText ~= "" and newDropText ~= ".") then
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame.AddBtn:Enable();
				else
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.LootObtentionFrame.AddBtn:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_vendorName = {
	frameType = "textbox",
	width = 210,
	title = core.L["Nom PNJ"],
	frameTitle = "ST_Obtention_vendorName",
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				if (_G["WCC_textbox_ST_Obtention_vendorName"]:GetText() ~= "") then
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame.AddBtn:Enable();
				else
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.VendorObtentionFrame.AddBtn:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_Professions = {
	frameType = "dropdownmenu",
	width = 175,
	title = "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r "..core.L["Aucun"],
	frameTitle = "ST_Obtention_Professions",
	info = {
		{	text = core.L["Professions"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Aucun"],
			arg1 = core.L["Aucun"],
			arg2 = "none",
			func = function(self, arg1, arg2)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][1],
			arg1 = core.L["ProfessionsList"][1],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][2],
			arg1 = core.L["ProfessionsList"][2],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][3],
			arg1 = core.L["ProfessionsList"][3],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][4],
			arg1 = core.L["ProfessionsList"][4],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][5],
			arg1 = core.L["ProfessionsList"][5],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][6],
			arg1 = core.L["ProfessionsList"][6],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][7],
			arg1 = core.L["ProfessionsList"][7],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][8],
			arg1 = core.L["ProfessionsList"][8],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][9],
			arg1 = core.L["ProfessionsList"][9],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][10],
			arg1 = core.L["ProfessionsList"][10],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][11],
			arg1 = core.L["ProfessionsList"][11],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][12],
			arg1 = core.L["ProfessionsList"][12],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][13],
			arg1 = core.L["ProfessionsList"][13],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["ProfessionsList"][14],
			arg1 = core.L["ProfessionsList"][14],
			func = function(self, arg1)
				if (arg1 ~= WCCreator_Lib.structures.SettingsTask_value.obtention_profession) then
					WCCreator_Lib.structures.SettingsTask_value.obtention_profession = arg1;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Obtention_Professions"], "|cFFF5CC00"..core.L["Professions"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.fs_Obtention_desc:SetText(WC_Lib.RefreshCompoCreate(WCCreator_Lib.structures.SettingsTask_value.obtention_create, WCCreator_Lib.structures.SettingsTask_value.obtention_profession));
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_createIdItem = {
	frameType = "textbox",
	width = 140,
	title = core.L["ID Objet"],
	frameTitle = "ST_Obtention_createIdItem",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				if (_G["WCC_textbox_ST_Obtention_createIdItem"]:GetText() ~= "" and _G["WCC_textbox_ST_Obtention_createNbNeed"]:GetText() ~= "") then
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame.AddBtn:Enable();
				else
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame.AddBtn:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Obtention_createNbNeed = {
	frameType = "textbox",
	width = 60,
	title = core.L["Nombre"],
	frameTitle = "ST_Obtention_createNbNeed",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				if (_G["WCC_textbox_ST_Obtention_createIdItem"]:GetText() ~= "" and _G["WCC_textbox_ST_Obtention_createNbNeed"]:GetText() ~= "") then
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame.AddBtn:Enable();
				else
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.CreateObtentionFrame.AddBtn:Disable();
				end
			end	
		},
	}
};

WCCreator_Lib.structures.ST_Validation = {
	frameType = "dropdownmenu",
	width = 210,
	title = "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r "..core.L["Manuelle"],
	frameTitle = "ST_Validation",
	info = {
		{	text = core.L["Validation"],
			isTitle = true,
			notCheckable = true,
		},
		{	text = core.L["Manuelle"],
			arg1 = core.L["Manuelle"],
			arg2 = "manual",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Avec quête"],
			arg1 = core.L["Avec quête"],
			arg2 = "quest",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetWidth(150);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Validation, "BOTTOM", -20, -15);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Show();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Avec haut-fait"],
			arg1 = core.L["Avec haut-fait"],
			arg2 = "hf",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetWidth(210);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Validation, "BOTTOM", 0, -15);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Avec monture"],
			arg1 = core.L["Avec monture"],
			arg2 = "mounts",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetWidth(210);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Validation, "BOTTOM", 0, -15);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Avec mascotte"],
			arg1 = core.L["Avec mascotte"],
			arg2 = "pets",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetWidth(210);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Validation, "BOTTOM", 0, -15);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Hide();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
		{	text = core.L["Avec transmog"],
			arg1 = core.L["Avec transmog"],
			arg2 = "transmogs",
			func = function(self, arg1, arg2)
				if (arg2 ~= WCCreator_Lib.structures.SettingsTask_value.validationType) then
					WCCreator_Lib.structures.SettingsTask_value.validationType = arg2;
					UIDropDownMenu_SetText(_G["WCC_dropdownmenu_ST_Validation"], "|cFFF5CC00"..core.L["Validation"]..core.L["2points"].."|r " ..arg1);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetWidth(150);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_IdValidation:SetPoint("TOP", _G["WCC_MenuSettingsTaskFrame"].ItemFrame.ddm_Validation, "BOTTOM", -20, -15);
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.tb_ModIdValidation:Show();
					_G["WCC_MenuSettingsTaskFrame"].ItemFrame.chbx_HiddenQuest:Hide();
					WCCreator_Lib.SetSizeMenuSettingsTask();
					CloseDropDownMenus();
				end
			end
		},
	}
};

WCCreator_Lib.structures.ST_IdValidation = {
	frameType = "textbox",
	width = 210,
	title = core.L["ID Validation"],
	desc = core.L["Correspond à l'ID de votre choix de validation (ID de quête, de haut-fait, de monture...)"],
	frameTitle = "ST_IdValidation",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.validationId = _G["WCC_textbox_ST_IdValidation"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_ModIdValidation = {
	frameType = "textbox",
	width = 65,
	title = core.L["ModID"],
	desc = core.L["Correspond à des variations d'apparences de l'objet de base (uniquement lorsque l'objet possède plusieurs apparences)"],
	frameTitle = "ST_ModIdValidation",
	nbOnly = true,
	event = {
		{
			name = "OnTextChanged",
			func = function(self)
				WCCreator_Lib.structures.SettingsTask_value.validationModId = _G["WCC_textbox_ST_ModIdValidation"]:GetText();
			end	
		},
	}
};

WCCreator_Lib.structures.ST_HiddenQuestValidation = {
	frameType = "checkbox",
	title = core.L["Quête cachée"],
	desc = core.L["HiddenQuestDesc"],
	size = 30,
	frameTitle = "ST_HiddenQuestValidation",
	disabled = false,
	func = function()
		WCCreator_Lib.structures.SettingsTask_value.bAutoRefresh = _G["WCC_checkbox_ST_HiddenQuestValidation"]:GetChecked();
	end,
};



WCCreator_Lib.structures.WCCJoinMenu = {
	info = {
		{	text = "DISCORD",
			notCheckable = true,
			disabled = false,
			func = function(self)
				StaticPopup_Show("DISCORD");
			end
		},
		{	text = "=======",
			isTitle = true,
			notCheckable = true,
			disabled = true,
		},
		{   text = "PATREON",
			notCheckable = true,
			disabled = false,
			func = function(self, arg1)
				StaticPopup_Show("PATREON");
			end
		},
	}
};


-- ===== CONFIG PANEL ====== --
WCCreator_Lib.structures.Config_ActivateID = {
	frameType = "checkbox",
	title = "|cffffffff"..core.L["Affichage IDs"].."|r",
	desc = core.L["Activer/Désactiver l'affichage des ID des hauts-faits, montures, mascottes, transmog, quêtes, PNJ et objets dans les info-bulles du jeu."],
	size = 25,
	frameTitle = "Config_ActivateID",
	disabled = false,
	func = function()
		TooltipIDShow = not TooltipIDShow;
	end,
};